function BubbleChartUtil(){
  componentUtil.call(this);

  this.getDefaultValue = function (that, options) {
      var dependencyObject = options.dependencyObject;
      var vbiCharts =dependencyObject.VbiCharts;//jshint ignore:line
      var seriesLibrary = dependencyObject.SeriesLibrary;//jshint ignore:line
      var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue;//jshint ignore:line
      var DataUtilityLib =dependencyObject.dataUtilityLib;//jshint ignore:line
      var vbiContextMenu=dependencyObject.VBIContextMenuLibray;//jshint ignore:line
      var vbiNumberFormat = dependencyObject.VbiNumberFormat;//jshint ignore:line
      var component = that.$();
        //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset === 0 ||titleoffset === '' || titletext === ' '){
        return null;
      } else if (titledisplay === true || titledisplay === "true") {
        return titleoffset;
      } else {
        return null;
      }
    };

      //To stop loading the fireeven twice - 1200 -- Vignesh G.
      var isLoad = false;
      var lassoObj = SeriesLibrary.prototype.lasso;

      var thousandseptool, decimalseptool,thousandsep,decimalsep;
      thousandseptool = that.tooltipthousandseparator();
      decimalseptool = that.tooltipdecimalseparator();
      thousandsep = that.progressthousandseparator();
      decimalsep = that.progressdecimalseparator();
      var defaultValue = {
          chart: {
            type: 'bubble',
            //alignTicks:that.chartalignticks(),//applicable in multiple axes
            className: that.chartcssclassname(),
            events: {
              click: function(event) {
                lassoObj.unselectByClick.call(this, that);
                if (event.target.textContent === '') {
                  that.fireEvent('chartonclick');
                }
              },

              load: function() {
  		 if(vbiContextMenu){vbiContextMenu.highchartsPostProcess();}
                      /*var contextMenuOptions={event:event,
                                      enableContextMenu:that.enableContextMenu(),
                                      enableDisplayDataButton:that.enableDisplayDataButton(),
                                      enableMaximizeButton:that.enableMaximizeButton(),
                                      enableMoreActionsButton:that.enableMoreActionsButton()};

                //The If condition is fire the charafterload event only once - Fix 1200
                vbiContextMenu.attachContextMenu(contextMenuOptions);*/

                //The If condition is fire the charafterload event only once - Fix 1200
                if (!isLoad) {
                  that.fireEvent('chartafterload');
                  isLoad = true;
                }

                if (that.creditsenabled() === true) {
                  this.credits.element.onclick = function() {
                    window.open(that.creditshref(), '_blank' // <- This is what makes it open in a new window.
                    );
                  };
                }
              },

              selection: function(e) {
                var retVal = lassoObj.selectPointsByDrag.call(this, e, that);
                if (this.lasso == 'lasso' || this.lasso == 'rlasso') {
                  that.fireEvent('chartonpointclick');
                } else {
                  if(e.xAxis) {that.fireEvent('chartonselect'); }//disabling the fireEvent while zoom out.
                }

                return retVal;
              },

              redraw: function() {
                if (that.noData === 0 && that.legendenable() && $(component).find('.highcharts-button').text().indexOf('Reset zoom') == -1) {//jshint ignore:line
                    var chart = component.highcharts();
                    var series = chart.series;
                    var islegendhide = false;
                    series.forEach(function(element,index) {
                      if(!series[index].visible) {
                           islegendhide = true;
                          }
                    });
                    if(!islegendhide){
                     that.afterUpdate();
                    }

                }
              }
            },
            ignoreHiddenSeries: that.ignorehiddenseries(),
            marginBottom: that.chartmarginbottom() == 'auto' ? null : Number(that.chartmarginbottom()),
            marginLeft: that.chartmarginleft() == 'auto' ? null : Number(that.chartmarginleft()),
            marginRight: that.chartmarginright() == 'auto' ? null : Number(that.chartmarginright()),
            marginTop: that.chartmargintop() == 'auto' ? null : Number(that.chartmargintop()),
            spacingBottom: that.chartpaddingbottom() == 'auto' ? null : Number(that.chartpaddingbottom()),
            spacingLeft: that.chartpaddingleft() == 'auto' ? null : Number(that.chartpaddingleft()),
            spacingRight: that.chartpaddingright() == 'auto' ? null : Number(that.chartpaddingright()),
            spacingTop: that.chartpaddingtop() == 'auto' ? null : Number(that.chartpaddingtop()),
            //spacingLeft: 100,
            //inverted:that.swapaxes(),
            pinchType: that.chartpinchtype(),
            zoomType: that.chartzoomtype(),
            panning: that.chartpanning(),
            panKey: that.chartpankey(),
            plotShadow: that.plotshadow(),
            reflow: that.chartflow() || false,
            shadow: that.chartshadow(),
            showaxes: that.showaxes(),
            resetZoomButton: {
              position: {
                align: that.zoombuttonalign(),
                //relativeTo:that.zoombuttonrelativeto(),
                verticalAlign: that.zoombuttonverticalalign()
              },
              theme: {
                fill: that.resetzoombuttonbackgroundcolor(),
                r: that.resetzoombuttonradius(),
                style: {
                  color: that.resetzoombuttontextcolor()
                },
                states: {
                  hover: {
                    fill: that.resetzoombuttonhoverbackgroundcolor(),
                    style: {
                      color: that.resetzoombuttonhovertextcolor()
                    }
                  }
                }
              }
            },
            backgroundColor: that.chartbackgroundcolor(),
            borderColor: that.chartbordercolor(),
            borderRadius: that.chartborderradius(),
            borderWidth: that.chartborderwidth(),
            plotBackgroundColor: that.plottransparency() === true ? 'transparent' : that.plotbackgroundcolor(),
            plotBackgroundImage: that.plotbackgroundimage(),
            plotBorderColor: that.plotbordercolor(),
            plotBorderWidth: that.plotborderwidth(),
            selectionMarkerFill: that.zoomselectionareabackgroundcolor()
          },
          boost : {
            enable : false // to turn off highboost
          },
          title:vbiHighchartsDefault.createDefaultObjects('commonTitle',that),
          subtitle:vbiHighchartsDefault.createDefaultObjects('commonSubtitle',that),
          credits:vbiHighchartsDefault.createDefaultObjects('commonCredits',that),
          exporting:vbiHighchartsDefault.createDefaultObjects('commonExporting',that),
          navigation:vbiHighchartsDefault.createDefaultObjects('commonNavigation',that),
          loading:vbiHighchartsDefault.createDefaultObjects('commonLoading',that),
          legend: vbiHighchartsDefault.createDefaultObjects('commonLegend',that),
          xAxis: [{
            crossing: that.xaxiscrossvalue().trim() == 'auto' || that.xaxiscrossvalue().trim() === '' ? null : Number(that.xaxiscrossvalue()),
            allowDecimals: that.xaxisallowdecimals(),
            alternateGridColor: that.xaxisalternategridcolor(),
            gridLineColor: that.xaxisgridlinecolor(),
            gridLineDashStyle: that.xaxisgridlinedashstyle(),
            gridLineWidth: that.xaxisgridlinewidth(),
            gridZIndex: that.xaxisgridzindex(),
            ceiling: that.xaxisceiling() === '' ? null : _.parseInt(that.xaxisceiling()),
            floor: that.xaxisfloor() === '' ? null : _.parseInt(that.xaxisfloor()),
            lineColor: that.xaxislinecolor(),
            lineWidth: that.xaxislinewidth(),
            minRange: that.xaxisminrange(),
            min: that.xaxismin() === '' ? null : _.parseInt(that.xaxismin()),
            max: that.xaxismax() === '' ? null : _.parseInt(that.xaxismax()),
            maxPadding: that.xaxismaxpadding() === '' ? null : _.parseInt(that.xaxismaxpadding()),
            minPadding: that.xaxisminpadding() === '' ? null : _.parseInt(that.xaxisminpadding()),
            opposite: that.xaxisopposite() ? true : that.xaxiscrossvalue().trim() == 'auto' || that.xaxiscrossvalue().trim() === '' ? false : true,
            offset: that.xaxisoffset(),
            reversed: that.xaxisreversed() === true,
            showEmpty: that.xaxisshowempty(),
            showFirstLabel: that.xaxisshowfirstlabel(),
            showLastLabel: that.xaxisshowlastlabel(),
            dateTimeLabelFormats: {},
            startOnTick: false, //that.xaxisstartontick(),
            endOnTick: that.xaxisendontick(),
            tickColor: that.xaxistickcolor(),
            tickInterval: that.xaxistickinterval() == '0' || that.xaxistickinterval() === '' ? null : _.parseInt(that.xaxistickinterval()),
            tickLength: that.xaxisticklength(),
            tickPosition: that.xaxistickposition(),
            tickWidth: that.xaxistickwidth(),
            tickmarkPlacement: that.xaxistickmarkplacement(),
            minTickInterval: that.xaxismintickinterval(),
            minorGridLineColor: that.xaxisminorgridlinecolor(),
            minorGridLineDashStyle: that.xaxisminorgridlinedashstyle(),
            minorGridLineWidth: that.xaxisminorgridlinewidth(),
            minorTickColor: that.xaxisminortickcolor(),
            minorTickInterval: that.xaxisminortickinterval() == '0' ? 'auto' : _.parseInt(that.xaxisminortickinterval()),
            minorTickLength: that.xaxisminorticklength(),
            minorTickPosition: that.xaxisminortickposition(),
            minorTickWidth: that.xaxisminortickwidth(),
            labels: {
              align: that.xaxislabelalign(),
              enabled: that.xaxislabelenabled(),
              formatter: function(){
                return vbiHighchartsDefault.XaxisAutoscaleFormatter(that,this);
              },
              //format: that.xaxislabelprefix() + that.xaxislabelformat() +
              //that.xaxislabelsuffix(),
              //overflow:that.xaxislabeloverflow(),
              //condition is aaplied to avoid chart not responding state
              rotation: that.xaxislabelrotation() < 0 ? 0 : that.xaxislabelrotation(),
              //distance:that.xaxislabeldistance(),
              staggerLines: that.xaxislabelstaggerline() === '' ? null : _.parseInt(that.xaxislabelstaggerline()),
              maxStaggerLines: that.xaxislabelmaxstaggerline() === '' ? null : _.parseInt(that.xaxislabelmaxstaggerline()),
              step: that.xaxislabelstep(),
              x: that.xaxislabelx(),
              y: that.xaxislabely(),
              zIndex: that.xaxislabelzindex(),
              style: {
                color: that.xaxislabelcolor(),
                fontWeight: that.xaxislabelfontweight(),
                textDecoration: that.xaxislabelfontweight(),
                fontSize: that.xaxislabelfontsize() + 'px',
                fontFamily: that.xaxislabelfontfamily()
              }
            },
            title: {
              useHTML: true,
              text: that.xaxistitletext(),
              align: that.xaxistitlealign(),
              rotation: that.xaxistitlerotation(),
              offset: offsetaxis(that.xaxistitleenabled(), that.xaxistitleoffset(), that.xaxistitletext()),
              margin: that.xaxistitlemargin(),
              style: {
                color: that.xaxistitlecolor(),
                fontWeight: that.xaxistitlefontweight(),
                textDecoration: that.xaxistitlefontweight(),
                fontSize: that.xaxistitlefontsize() + 'px',
                fontFamily: that.xaxistitlefontfamily(),
                display: that.xaxistitleenabled() === true ? 'block' : 'none'
              }
            },
            plotBands: [{
              style: {
                display: that.xaxisplotbandenabled() === true ? 'block' : 'none'
              },
              color: that.xaxisplotbandenabled() === true ? that.xaxisplotbandcolor() : null,
              borderColor: that.xaxisplotbandenabled() === true ? that.xaxisplotbandbordercolor() : null,
              borderWidth: that.xaxisplotbandborderwidth(),
              from: that.xaxisplotbandfrom() - 0.5,
              to: that.xaxisplotbandto() + 0.5,
              zIndex: that.xaxisplotbandzindex(),
              events: {
                click: function() {
                  that.fireEvent('xaxisplotbandonclick');
                }
              },
              label: {
                style: {
                  color: that.xaxisplotbandlabelcolor(),
                  fontWeight: that.xaxisplotbandlabelfontweight(),
                  textDecoration: that.xaxisplotbandlabelfontweight(),
                  fontSize: that.xaxisplotbandlabelfontsize() + 'px',
                  fontFamily: that.xaxisplotbandlabelfontfamily(),
                  display: that.xaxisplotbandlabelenabled() === true ? 'block' : 'none'
                },
                text: that.xaxisplotbandlabeltext(),
                align: that.xaxisplotbandlabelalign(),
                rotation: that.xaxisplotbandlabelrotation(),
                textAlign: that.xaxisplotbandlabeltextalign(),
                //useHTML:that.xaxisplotbandlabelusehtml(),
                verticalAlign: that.xaxisplotbandlabelverticalalign(),
                x: that.xaxisplotbandlabelxposition() == 'null' ? null : _.parseInt(that.xaxisplotbandlabelxposition()),
                y: that.xaxisplotbandlabelyposition() === '' ? null : _.parseInt(that.xaxisplotbandlabelyposition())
              }
            }],
            plotLines: [{
              color: that.xaxisplotlineenabled() === true ? that.xaxisplotlinecolor() : null,
              dashStyle: that.xaxisplotlinedashstyle(),
              width: that.xaxisplotlinewidth(),
              value: that.xaxisplotlinevalue(),
              zIndex: that.xaxisplotlinezindex(),
              label: {
                style: {
                  color: that.xaxisplotlinelabelcolor(),
                  fontWeight: that.xaxisplotlinelabelfontweight(),
                  textDecoration: that.xaxisplotlinelabelfontweight(),
                  fontSize: that.xaxisplotlinelabelfontsize() + 'px',
                  fontFamily: that.xaxisplotlinelabelfontfamily(),
                  display: that.xaxisplotlinelabelenabled() === true ? 'block' : 'none'
                },
                text: that.xaxisplotlinelabeltext(),
                align: that.xaxisplotlinelabelalign(),
                rotation: that.xaxisplotlinelabelrotation(),
                textAlign: that.xaxisplotlinelabeltextalign(),
                verticalAlign: that.xaxisplotlinelabelverticalalign(),
                x: that.xaxisplotlinelabelxposition() == 'null' ? null : _.parseInt(that.xaxisplotlinelabelxposition()),
                y: that.xaxisplotlinelabelyposition() == 'null' ? null : _.parseInt(that.xaxisplotlinelabelyposition())
              }
            }]
          }, {
            left: that.$().width() - 150,
            right: that.chartpaddingright() == 'auto' ? 0 : Number(that.chartpaddingright()),
            width: 150,
            visible: false,
            zoomEnabled: false,
            zIndex: 5000
          }],
          yAxis: [{
            crossing: that.yaxiscrossvalue() == 'auto' || that.yaxiscrossvalue() === '' ? null : Number(that.yaxiscrossvalue()),
            allowDecimals: that.yaxisallowdecimals(),
            alternateGridColor: that.yaxisalternategridcolor(),
            gridLineColor: that.yaxisgridlinecolor(),
            gridLineDashStyle: that.yaxisgridlinedashstyle(),
            gridLineWidth: that.yaxisgridlinewidth(),
            gridZIndex: that.yaxisgridzindex(),
            lineColor: that.yaxislinecolor(),
            lineWidth: that.yaxislinewidth(),
            minTickInterval: that.yaxismintickinterval(),
            minorGridLineColor: that.yaxisminorgridlinecolor(),
            minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
            minorGridLineWidth: that.yaxisminorgridlinewidth(),
            minorTickColor: that.yaxisminortickcolor(),
            minorTickInterval: that.yaxisminortickinterval() == '0' ? 'auto' : _.parseInt(that.yaxisminortickinterval()),
            minorTickLength: that.yaxisminorticklength(),
            minorTickPosition: that.yaxisminortickposition(),
            minorTickWidth: that.yaxisminortickwidth(),
            tickColor: that.yaxistickcolor(),
            tickInterval: that.yaxistickinterval() === '0' || that.yaxistickinterval() === '' || that.yaxistickinterval() === 0 ? null : _.parseInt(that.yaxistickinterval()),
            tickLength: that.yaxisticklength(),
            tickPosition: that.yaxistickposition(),
            tickWidth: that.yaxistickwidth(),
            tickmarkPlacement: that.yaxistickmarkplacement(),
            dateTimeLabelFormats: {},
            ceiling: that.yaxisceiling() === '' ? null : _.parseInt(that.yaxisceiling()),
            floor: that.yaxisfloor() === '' ? null : _.parseInt(that.yaxisfloor()),
            min: that.yaxismin() === '' ? null : _.parseInt(that.yaxismin()),
            max: that.yaxismax() === '' ? null : _.parseInt(that.yaxismax()),
            maxPadding: that.yaxismaxpadding() === '' ? null : parseFloat(that.yaxismaxpadding()),
            minPadding: that.yaxisminpadding() === '' ? null : parseFloat(that.yaxisminpadding()),
            minRange: that.yaxisminrange(),
            offset: that.yaxisoffset(),
            opposite: that.yaxisopposite(),
            reversed: that.yaxisreversed() === true,
            showEmpty: that.yaxisshowempty(),
            showFirstLabel: that.yaxisshowfirstlabel(),
            showLastLabel: that.yaxisshowlastlabel(),
            startOnTick: true, //that.yaxisstartontick(),//negative value is not getting show in axis .since making it true for default
            //          endOnTick: that.yaxisendontick(),
            labels: {
              align: that.yaxistitleenabled() === false || that.yaxistitletext() === '' ? 'right' : that.yaxislabelalign(),
              enabled: that.yaxislabelenabled(),
              formatter: function(){
                return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that,this);
              },
              rotation: that.yaxislabelrotation(),
              staggerLines: that.yaxislabelstaggerline() === '' ? null : _.parseInt(that.yaxislabelstaggerline()),
              maxStaggerLines: that.yaxislabelmaxstaggerline() === '' ? null : _.parseInt(that.yaxislabelmaxstaggerline()),
              step: that.yaxislabelstep(),
              x: that.yaxislabelx(),
              y: that.yaxislabely(),
              zIndex: that.yaxislabelzindex(),
              style: {
                color: that.yaxislabelcolor(),
                fontWeight: that.yaxislabelfontweight(),
                textDecoration: that.yaxislabelfontweight(),
                fontSize: that.yaxislabelfontsize() + 'px',
                fontFamily: that.yaxislabelfontfamily()
              }
            },
            title: {
              text: that.yaxistitletext(),
              align: that.yaxistitlealign(),
              rotation: that.yaxistitlerotation(),
              offset: offsetaxis(that.yaxistitleenabled(), that.yaxistitleoffset(), that.yaxistitletext()),
              margin: that.yaxistitlemargin(),
              style: {
                color: that.yaxistitlecolor(),
                fontWeight: that.yaxistitlefontweight(),
                textDecoration: that.yaxistitlefontweight(),
                fontSize: that.yaxistitlefontsize() + 'px',
                fontFamily: that.yaxistitlefontfamily(),
                display: that.yaxistitleenabled() === true ? 'block' : 'none'
              }
            },
            plotBands: [{
              color: that.yaxisplotbandenabled() === true ? that.yaxisplotbandcolor() : null,
              borderColor: that.yaxisplotbandenabled() === true ? that.yaxisplotbandbordercolor() : null,
              borderWidth: that.yaxisplotbandborderwidth(),
              from: that.yaxisplotbandfrom(),
              to: that.yaxisplotbandto(),
              zIndex: that.yaxisplotbandzindex(),
              events: {
                click: function() {
                  that.fireEvent('yaxisplotbandonclick');
                }
              },
              label: {
                style: {
                  color: that.yaxisplotbandlabelcolor(),
                  fontWeight: that.yaxisplotbandlabelfontweight(),
                  textDecoration: that.yaxisplotbandlabelfontweight(),
                  fontSize: that.yaxisplotbandlabelfontsize() + 'px',
                  fontFamily: that.yaxisplotbandlabelfontfamily(),
                  display: that.yaxisplotbandlabelenabled() === true ? 'block' : 'none'
                },
                text: that.yaxisplotbandlabeltext(),
                align: that.yaxisplotbandlabelalign(),
                rotation: that.yaxisplotbandlabelrotation(),
                textAlign: that.yaxisplotbandlabeltextalign(),
                verticalAlign: that.yaxisplotbandlabelverticalalign(),
                x: that.yaxisplotbandlabelxposition() == 'null' ? null : _.parseInt(that.yaxisplotbandlabelxposition()),
                y: that.yaxisplotbandlabelyposition() == 'null' ? null : _.parseInt(that.yaxisplotbandlabelyposition())
              }
            }],
            plotLines: [{
              color: that.yaxisplotlineenabled() === true ? that.yaxisplotlinecolor() : null,
              dashStyle: that.yaxisplotlinedashstyle(),
              width: that.yaxisplotlinewidth(),
              value: that.yaxisplotlinevalue(),
              zIndex: that.yaxisplotlinezindex(),
              label: {
                verticalAlign: that.yaxisplotlinelabelverticalalign(),
                style: {
                  color: that.yaxisplotlinelabelcolor(),
                  fontWeight: that.yaxisplotlinelabelfontweight(),
                  textDecoration: that.yaxisplotlinelabelfontweight(),
                  fontSize: that.yaxisplotlinelabelfontsize() + 'px',
                  fontFamily: that.yaxisplotlinelabelfontfamily(),
                  display: that.yaxisplotlinelabelenabled() === true ? 'block' : 'none'
                },
                text: that.yaxisplotlinelabeltext(),
                align: that.yaxisplotlinelabelalign(),
                rotation: that.yaxisplotlinelabelrotation(),
                textAlign: that.yaxisplotlinelabeltextalign(),
                x: that.yaxisplotlinelabelxposition() == 'null' ? null : _.parseInt(that.yaxisplotlinelabelxposition()),
                y: that.yaxisplotlinelabelyposition() == 'null' ? null : _.parseInt(that.yaxisplotlinelabelyposition())
              }
            }]
          }, {
            top: that.chartpaddingtop() == 'auto' ? 10 : Number(that.chartpaddingtop()) + 10,
            height: 150,
            visible: false,
            zoomEnabled: false

          }],
          tooltip: {
            useHTML: true,
            animation: that.tooltipanimation() || false,
            crosshairs: that.tooltipcrosshair(),
            enabled: that.tooltipenable(),
            followPointer: that.tooltipfollowpointer(),
            followTouchMove: that.tooltipfollowtouchmove(),
            hideDelay: that.tooltiphidedelay(),
            shadow: that.tooltipshadow(),
            shape: that.tooltipshape(),
            shared: that.tooltipshared(),
            snap: that.tooltipsnap(),
            padding: that.tooltipshape() == "circle"? 18:8,
            valueDecimals: that.tooltipvaluedecimals(),
            valuePrefix: that.tooltipvalueprefix(),
            valueSuffix: that.tooltipvaluesuffix(),
            headerFormat: '',
            //               pointFormat:'<span style="color:{point.color}">\u25CF</span><b>{series.name}</b><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">{point.name}</p><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em"> <p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">{series.options.xAxisLabel}(x):{point.series.tooltipOptions.valuePrefix}{point.x}{point.series.tooltipOptions.valueSuffix}</p> <p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">{series.options.yAxisLabel}(y):{point.y}</p><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em"> {series.options.zAxisLabel}(Size):{point.z}</p></p>',
            backgroundColor: that.tooltipbackgroundcolor(),
            borderColor: that.tooltipbordercolor(),
            borderRadius: that.tooltipborderradius(),
            borderWidth: that.tooltipborderwidth(),
            style: {
              color: that.tooltipcolor(),
              fontWeight: that.tooltipfontweight(),
              textDecoration: that.tooltipfontweight(),
              fontSize: that.tooltipfontsize() + 'px',
              fontFamily: that.tooltipfontfamily()
            }
          },
          plotOptions: {
            series: {
              marker: { fillOpacity:1 },
              cursor: 'pointer',
              pointWidth: that.pointwidth() == 'auto' ? null : _.parseInt(that.pointwidth()),
              pointPadding: that.pointpadding(),
              point: {
                events: {
                  click: function(event) {
                    that.selectedvalue(seriesLibrary.createMemberData(that, undefined, event.point.series.options.key + '-' + event.point.rowIndex)); //changed = 1;
                  },

                  select: function() {
                    if (!this.series.chart.lassoFlag) {
                      try {
                        that.selectedPoints = component.highcharts().getSelectedPoints();
                        that.selectedPoints.push(this);
                        that.selectedvalues(seriesLibrary.createMembersData(that, undefined, that.selectedPoints).toString());
                        seriesLibrary.onSelectFunction(that);
                      } catch (e) {
                        seriesLibrary.DSXalert(e.message);
                      }
                      /**
                      *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                      **/
                    }
                  },

                  unselect: function() {
                    if (!this.series.chart.lassoFlag) {
                   try{
                     // var unselectedPoints = component.highcharts().getSelectedPoints();
                      var index = that.selectedPoints.indexOf(this);
                      if (index > -1) {
                        that.selectedPoints.splice(index, 1);
                      }

                      that.selectedvalues(seriesLibrary.createMembersData(that, undefined, that.selectedPoints).toString());
                   } catch (e) {   seriesLibrary.DSXalert(e.message);
                      }
                      seriesLibrary.onSelectFunction(that);
                      /**
                      *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                      **/
                    }
                  }
                }
              },
              allowPointSelect: true,
              connectNulls: that.connectnulls(),
              cropThreshold: that.cropthreshold(),
              turboThreshold: that.turbothreshold(),
              minSize: that.zaxisminsize() === '' || that.zaxisminsize() === null ? 8 : that.zaxisminsize(),
              maxSize: that.zaxismaxsize() === '' || that.zaxismaxsize() === null ? 20 + '%' : that.zaxismaxsize(),
              zMin: that.zaxismin() === '' || that.zaxismin() === null ? null : that.zaxismin(),
              zMax: that.zaxismax() === '' || that.zaxismax() === null ? null : that.zaxismax(),
              dataLabels: {
                useHTML:false,
                allowOverlap: that.allowoverlap(),
                enabled: that.datalabelenabled(),
                align: that.datalabelalign(),
                crop: that.datalabelcrop(),
                //defer: that.datalabeldefer(),
                backgroundColor: that.datalabelbackgroundcolor(),
                borderColor: that.datalabelbordercolor(),
                borderRadius: that.datalabelborderradius(),
                borderWidth: that.datalabelborderwidth(),
                padding: that.datalabelpadding(),
                rotation: that.datalabelrotation(),
                shadow: that.datalabelshadow(),
                verticalAlign: that.datalabelverticalalign(),
                x: that.datalabelx(),
                y: that.datalabely(),
                formatter: function() {
                 if(this.color == " "){
                  return;
                 }else if(that.customdatalabel() !== ""  && Object.keys(JSON.parse(that.customdatalabel()||'{}')).length && this.point.series.name.toLocaleLowerCase().indexOf('result') == -1){
                    return vbiNumberFormat.drillDownFamilyFormatterDataLabel(this,that,decimalsep,decimalsep,false);
                  }else {
                    if (that.datalabeltype() == 'dimension') {
                      var dimension = this.series.name + (this.point.name.trim() === '' ? '' : '/') + this.point.name + '</br>';
                      return dimension;
                    }else{
                      return vbiNumberFormat.scatterDataLabelFormatter(this,that,decimalsep,thousandsep);
                    }
                  }
                },

                style: {
                  textShadow: false,
                  color: that.datalabeltextcolor(),
                  fontWeight: that.datalabelfontweight(),
                  textDecoration: that.datalabelfontweight(),
                  fontSize: that.datalabelfontsize() + 'px',
                  fontFamily: that.globalfont() === true ? this.fontfamily() : that.datalabelfontfamily()
                }
              }

            }
          },
          series: options.seriesData
        };
      return defaultValue;
  }
  this.getSampleDataSeries = function () {
      var seriesData = [
        {data: [
                  {
                    name: 'Point 1',
                    x: 97,
                    y: 36,
                    z: 79
                  },
                  {
                    name: 'Point 2',
                    x: 94,
                    y: 74,
                    z: 60
                  }, {
                    name: 'Point 3',
                    x: 68,
                    y: 76,
                    z: 58
                  }, {
                    name: 'Point 4',
                    x: 64,
                    y: 87,
                    z: 56
                  }, {
                    name: 'Point 5',
                    x: 68,
                    y: 27,
                    z: 73
                  }, {
                    name: 'Point 6',
                    x: 74,
                    y: 99,
                    z: 42
                  }, {
                    name: 'Point 7',
                    x: 7,
                    y: 93,
                    z: 87
                  }, {
                    name: 'Point 8',
                    x: 51,
                    y: 69,
                    z: 40
                  }, {
                    name: 'Point 9',
                    x: 38,
                    y: 23,
                    z: 33
                  }, {
                    name: 'Point 10',
                    x: 57,
                    y: 86,
                    z: 31
                  }
              ],
              color: '#588EC0'
          }, {
            data: [{
              name: 'Point 11',
              x: 25,
              y: 10,
              z: 87
            }, {
              name: 'Point 12',
              x: 2,
              y: 75,
              z: 59
            }, {
              name: 'Point 13',
              x: 11,
              y: 54,
              z: 8
            }, {
              name: 'Point 14',
              x: 86,
              y: 55,
              z: 93
            }, {
              name: 'Point 15',
              x: 5,
              y: 3,
              z: 58
            }, {
              name: 'Point 16',
              x: 90,
              y: 63,
              z: 44
            }, {
              name: 'Point 17',
              x: 91,
              y: 33,
              z: 17
            }, {
              name: 'Point 18',
              x: 97,
              y: 3,
              z: 56
            }, {
              name: 'Point 19',
              x: 15,
              y: 67,
              z: 48
            }, {
              name: 'Point 20',
              x: 54,
              y: 25,
              z: 81
            }],
            color: '#FF9E5E'
          }, {
            data: [{
              name: 'Point 21',
              x: 47,
              y: 47,
              z: 21
            }, {
              name: 'Point 22',
              x: 20,
              y: 12,
              z: 4
            }, {
              name: 'Point 23',
              x: 6,
              y: 76,
              z: 91
            }, {
              name: 'Point 24',
              x: 38,
              y: 30,
              z: 60
            }, {
              name: 'Point 25',
              x: 57,
              y: 98,
              z: 64
            }, {
              name: 'Point 26',
              x: 61,
              y: 17,
              z: 80
            }, {
              name: 'Point 27',
              x: 83,
              y: 60,
              z: 13
            }, {
              name: 'Point 28',
              x: 67,
              y: 78,
              z: 75
            }, {
              name: 'Point 29',
              x: 64,
              y: 12,
              z: 10
            }, {
              name: 'Point 30',
              x: 30,
              y: 77,
              z: 82
            }],
            color: '#C6E06D'
          }
      ];
      return seriesData;

  }
  this.attachGetters=function(component,options){
    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.createxternalDimensionsfulljson = function(component) {
      var tempDimension = component['fulljson']();
      var dimeKey;
      if (tempDimension.dimensions) {
        if ('externalDimensions' in tempDimension && tempDimension.dimensions.length > 1) {
          tempDimension.dimensions[0].containsMeasures = true;
          //Adding Dummy Contain Measure
          for (var i = 0; i < tempDimension.externalDimensions.length; i++) {
            if (tempDimension.externalDimensions[i].containsMeasures) {
              dimeKey = i;
            }
          }
          //Getting externalDimensions-KeyFirgure Location.
          for (var j = 0; j < tempDimension.dimensions[0].members.length; j++) {
            tempDimension.dimensions[0].members[j].scalingFactor = tempDimension.externalDimensions[dimeKey].members[0].scalingFactor;
            tempDimension.dimensions[0].members[j].formatString = tempDimension.externalDimensions[dimeKey].members[0].formatString;
          } //Adding Measure Key Attributes to first-dimension value
        } //If externalDimensions is in JSON.
        else {
          var tempcontainsMeasures = false;
          for (var i = 0; i < tempDimension.dimensions.length; i++) {
            if ('containsMeasures' in tempDimension.dimensions[i]) {
              tempcontainsMeasures = true;
            }
          }

          if (!tempcontainsMeasures && tempDimension.dimensions.length > 1) {
            tempDimension.dimensions[0].containsMeasures = true;
            //Adding Dummy Contain Measure
            tempDimension.dimensions[0].noMeasure = true;
            for (var j = 0; j < tempDimension.dimensions[0].members.length; j++) {
              tempDimension.dimensions[0].members[j].scalingFactor = '';
              tempDimension.dimensions[0].members[j].formatString = '';
            } //Adding Measure Key Attributes to first-dimension value
          }
        }
      }
    };


  component.createIdentical = function(defaultValue) {
    var entireData = [];
    for (var i = 0; i < defaultValue.series.length; i++) {
    if(defaultValue.series[i].data){
      for (var j = 0; j < defaultValue.series[i].data.length; j++) {
        entireData.push(defaultValue.series[i].data[j].y);
      }
    }
    }

    if (entireData && entireData.length > 0) {
      component.minimumValue = entireData.reduce(function(p, v) {
        return p < v ? p : v;
      });

      component.maximumValue = entireData.reduce(function(p, v) {
        return p > v ? p : v;
      });
    }

    if (component.minimumValue === undefined) {
      component.minimumValue = 0;
      component.maximumValue = 250;
    }
    /*
     * If no data-source selected.
     */
    var datasourceAssigned = component['DATA_SOURCE_ALIAS_REF']();
    var chartId = component['id']();
    var restart = component['chartRestart']();
    var listGroup = component['list']();
    var testingArrayTemp = component['testingArray']();
    var minimumVal = Math.floor(component.minimumValue).toFixed(component.decimal());
    var maximumVal = Math.ceil(component.maximumValue).toFixed(component.decimal());
    var customMin = component['groupingyaxismin']();
    var customMax = component['groupingyaxismax']();
    if (WhatIfLibrary != undefined && listGroup != '' || restart != 0) { /* jshint ignore: line */
      WhatIfLibrary.register(chartId, {
        type: 'Chart',
        name: 'Bubble Chart',
        category: 'charts',
        "data_source" : datasourceAssigned,
        "custom_function": {
          "custom_id_min_value": minimumVal,
          "custom_id_max_value": maximumVal,
          "custom_id_groupId": testingArrayTemp,
          "custom_id_SelectedValue": listGroup,
          "custom_id_min": customMin,
          "custom_id_max": customMax
        }
      }, component);
    }
    /*
     * Getting the minimum and maximum value and pushing it to whatifAnalyser(updating).
     * and also grouping name.
     */
    component.globalVal.push('None');
    for (var i in WhatIfLibrary.charts) {
      if (WhatIfLibrary.charts[i]["custom_function"] !== undefined) {
        var gettingArray = WhatIfLibrary.charts[i]["custom_function"]["custom_id_groupId"];
        for (var j = 0; j < gettingArray.split(',').length; j++) {
          var localTest = gettingArray.split(',');
          if (component.globalVal.indexOf(localTest[j]) == -1) {
            component.globalVal.push(localTest[j]);
          }
        }
      }
    }

    //var tempMax = component.minimumValue;
    //var tempMin = component.maximumValue;
    seriesLibrary.creatIndenticalScaling(component, defaultValue, minimumVal, maximumVal, WhatIfLibrary);
    //identicalScaling Fix
    if (listGroup != '' || restart != 0) { // jshint ignore:line
      if (listGroup != 'None') {
        componentUtil.callHighCharts(component,component, defaultValue,{dependencyObject:dependencyObject,seriesData:seriesData});//jshint ignore:line
      }
    } //To stop the events
  };

  component.dataManipulation = function() {
    var seriesColor = component.dataseriescolor().split(',');
    var seriesData = [{}];
    var count = 0;
    var memberArray = vbiCharts.getMemberArray(component.dataRes, 'text', 0);
    //actual expected
    seriesData[0].name = memberArray[0];
    seriesData[0].data = [];
    var data = vbiCharts.getResultColumnArray(component.dataRes, 'text', 0);
    var members = vbiCharts.getResultColumnArray(component.dataRes, 'text', 1);
    for (var i = 0; i < data.length; i += memberArray.length) {
      seriesData[0].data.push({
        name: members[i],
        y: data[i],
        color: '#' + seriesColor[count]
      });
      count++;
    }

    return seriesData;
  };

  component.getDataSeriesColor = function() {
    return component.dataseriescolor();
  };

  component.isResultAvailable = function() {
    if (component.dataRes !== undefined && component.dataRes !== '' && component.dataRes !== 0) {
      if (component.keyfigureLength < 3) {
        return false;
      } else if (!component.isDimensionAvailable) {
        return false;
      } else {
        return true;
      }
    }

    return false;
  };

  component.clearbardatacustomization = function() {
    component.datautility(false);
    component.bardatacustomization("");
    component.firePropertiesChanged(['bardatacustomization']);
  };

 component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
    var seriesName = [];
    var seriesKey = [];

    try {
      if (component.dataRes !== undefined && component.dataRes !== '' && component.dataRes !== 0) {


        var rowSelected = [];
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
            rowSelected.push({index:i});
            if(!component.showtotaldatabase() && component.datautility() !== true){
              break;
            }
          }
        }

        if (component.keyfigureLength < 3) {
          component.noData = 1;
        } else if (!component.isDimensionAvailable) {
          component.noData = 2;
        } else if (rowSelected.length <= 0) {
          component.noData = 6;
        } else {
          var measureJson = JSON.parse(component.getMeasureJson());
          if (component.xaxismeasure() === null || component.xaxismeasure() === undefined || component.xaxismeasure() === '' || measureJson[component.xaxismeasure()] === undefined) {
            component.xaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[0].key);
          }

          if (component.yaxismeasure() === null || component.yaxismeasure() === undefined || component.yaxismeasure() === '' || measureJson[component.yaxismeasure()] === undefined) {
            component.yaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[1].key);
          }

          if (component.zaxismeasure() === null || component.zaxismeasure() === undefined || component.zaxismeasure() === '' || measureJson[component.zaxismeasure()] === undefined) {
            component.zaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[2].key);
          }

          if (rowSelected.length > 0) {
            var selectedRowIndex = -1;
            selectedRowIndex = rowSelected[0].index;

            if (selectedRowIndex != -1) {
              for (var i = 0; i < component.dataRes.dimensions[selectedRowIndex].members.length; i++) {
                if (component.dataRes.dimensions[selectedRowIndex].members[i].type != 'RESULT' || component.showtotaldatabase()) {
                  seriesName.push(component.dataRes.dimensions[selectedRowIndex].members[i].text);
                  seriesKey.push(component.dataRes.dimensions[selectedRowIndex].members[i].key);
                }
              }
            }
          }

          component.noData = 0;
        }
      }
    } catch (err) {}
    if (component.showtotal() === true) {
      seriesName.push('Total Result');
      seriesKey.push('Total Result');
    }
    if (component.noData !== 0) {
      seriesName = [];
      seriesKey = [];
      component.dataseriescolor('');
     // component.bardatacustomization('');
    }

    return [
        seriesName,
        seriesKey
    ];
  };

  component.componentDeleted = function() {
    $('#dsui_' + componentID).remove();

    function triggerDelete() {
      var chartId = component['id']();
      if (WhatIfLibrary !== undefined) {
        for (var i in WhatIfLibrary.charts) {
          if (i === chartId) {
            //Removing current instances from WhatIfLibrary
            delete WhatIfLibrary.charts[i];
            delete WhatIfLibrary.instances[i];
          }
        }
        /*
         *Deleting the Removed chart from the WhatIfLibrary
         *Manually Removed
         *WhatIfLibrary is removing only after window.refresh Hence removing Manually
         */
        for (var i in WhatIfLibrary.charts) {
          if (sap.zen.Dispatcher.instance.getRootControlForComponentId(i) !== undefined) {
            var instance = WhatIfLibrary.getInstance(i);
            if (instance.list() !== '' || instance.list() != 'None') {
              instance.afterUpdate();
            }
          }
          /*
           *Trigger afterUpdate of the charts which are grouped
           *Auto-AfterUpdate is not getting trigged
           */
        }
      }
    }

    setTimeout(triggerDelete, 200); //getRootControlForComponentId need a setTimeout
  };

  component["getTrendline_add"] = function() {
    return component.yaxisstartontick();
  };

  component["getTrendline_json"] = function() {
    return component.testingArrayjson().toString();
  };

  component.getTrendlineColor = function() {
    if (component.trendcolorpickervalue()) {
      return component.trendcolorpickervalue();
    } else
      {
         return false;
      }
  };

  component.lassoFireProp = function(selectedPoints) {
    component.selectedvalues(seriesLibrary.createMembersData(component, undefined, selectedPoints).toString());
   // columncolorChanged++;
    component.firePropertiesChanged(['selectedvalues']);
  };

  component.getChartFamily = function() {
    return 'bubble';
  };

  component.getMeasureJson = function() {
    var measureJson = {};
    for (var i = 0; i < component.dataRes.dimensions.length; i++) {
      if ('containsMeasures' in component.dataRes.dimensions[i]) {
        $.each(component.dataRes.dimensions[i].members, function(key, value) {
          measureJson[value.key] = {
            text: value.text,
            index: key
          };
        });

        break;
      }
    }

    return JSON.stringify(measureJson);
  };

  component.getDataLengthVal = function() {
    return JSON.stringify(component.result());
  };

  component.getChartType = function() {
    return 'bubble';
  };

  component.getDropdownName = function() {
    return component.list();
  };

  component.isMeasureOnly = function() {
    var len = 0;
    if (component.result() !== undefined && component.result() !== '') {
      try {
        len = component.result().dimensions.length;
      } catch (e) {
        seriesLibrary.DSXalert(e.message);
      }
    }

    return len;
  };

  component.getMeasureMembers = function() {
    try {
      return seriesLibrary.getMeasureMembers(component);
    } catch (e) {
      seriesLibrary.DSXalert(e.message);
    }
  };

  component.getMeasureMembers = function() {
    return seriesLibrary.getMeasureMembers(component);
  };

  component.getMeasuresNamesForFormatter = function(){
      return vbiNumberFormat.getMeasuresNamesForFormatter(component);
  };

  component.getChartNames = function() {
    return component.globalVal;
  };

  }
}
