function BulletChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function () {
      var seriesData = [{
              name: 'Bands 3',
              enableMouseTracking: false,
              borderWidth: 0,
              borderRadius: 0,
              stacking: 'normal',
              grouping: false,
              color: 'rgba(156,156,156,.1)',
              data: [
                  2,
                  1.5,
                  1.5,
                  1.5,
                  2
              ]
          },
          {
              name: 'Bands 2',
              enableMouseTracking: false,
              borderWidth: 0,
              borderRadius: 0,
              stacking: 'normal',
              grouping: false,
              color: 'rgba(156,156,156,.4)',
              data: [
                  2,
                  1.5,
                  1.5,
                  2,
                  3
              ]
          },
          {
              //pointRange:1.1,
              name: 'Bands 1',
              enableMouseTracking: false,
              borderWidth: 0,
              borderRadius: 0,
              stacking: 'normal',
              grouping: false,
              color: 'rgba(156,156,156,.7)',
              data: [
                  6,
                  7,
                  7,
                  6.5,
                  5
              ]
          },
          {
              name: 'Measure',
              pointRange: 0.5,
              zIndex: 10,
              data: [{
                      name: 'Bands 1',
                      y: 7,
                      color: 'rgba(56,56,56,1)'
                  },
                  {
                      name: 'Bands 2',
                      y: 5,
                      color: 'rgba(56,56,56,1)'
                  },
                  {
                      name: 'Bands 3',
                      y: 9,
                      color: 'rgba(56,56,56,1)'
                  },
                  {
                      name: 'Bands 4',
                      y: 3,
                      color: 'rgba(56,56,56,1)'
                  },
                  {
                      name: 'Bands 5',
                      y: 6,
                      color: 'rgba(56,56,56,1)'
                  }
              ]
          },
          {
              name: 'Target',
              type: 'scatter',
              zIndex: 20,
              marker: {
                  symbol: 'line',
                  lineWidth: 3,
                  //that.scattermarkerlinewidth()
                  radius: 10,
                  //that.scattermarkerlineradius()
                  lineColor: '#333' //
              },
              data: [
                  7.5,
                  8,
                  7.5,
                  8.5,
                  8.5
              ]
          }
      ];
      return seriesData;
  }

  this.getDefaultValue = function (that, options) {
      var selectedBullet;
      var dependencyObject = options.dependencyObject;
      var vbiCharts =dependencyObject.VbiCharts;
      var seriesLibrary = dependencyObject.SeriesLibrary;
      var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue;
      var vbiNumberFormat = dependencyObject.VbiNumberFormat;//jshint ignore:line
      var DataUtilityLib =dependencyObject.dataUtilityLib;//jshint ignore:line
      var vbiContextMenu=dependencyObject.VBIContextMenuLibray;//jshint ignore:line
      var lassoObj = SeriesLibrary.prototype.lasso;
      var isExportEnable=that.exportingsymbolenabled();
      var loadingfont = that.loadingfontweight().split(':');
      var suppressUnselectCall;
        //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
        //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset === '' || titletext === ' ') {
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };
    
      if(that.enableMoreActionsButton && isExportEnable)
      {
          isExportEnable=!that.enableMoreActionsButton() &&   !that.enableContextMenu();
      }
      var defaultValue = {
        chart: {
          type: that.bulletcharttype(),
          //inverted:that.chartinverted(),//shouldn't expose this property to user
          //alignTicks:that.chartalignticks(),//applicable in multiple axes
          className: that.chartcssclassname(),
          events: {
            click: function(event) {
              lassoObj.unselectByClick.call(this,that);
              if (event.target.textContent === '') {
                that.fireEvent('chartonclick');
              }
            },

            load: function() {
         if(vbiContextMenu){vbiContextMenu.highchartsPostProcess();}
                       /*var contextMenuOptions={event:event,
                                    enableContextMenu:that.enableContextMenu(),
                                    enableDisplayDataButton:that.enableDisplayDataButton(),
                                    enableMaximizeButton:that.enableMaximizeButton(),
                                    enableMoreActionsButton:that.enableMoreActionsButton()};

              //The If condition is fire the charafterload event only once - Fix 1200
              vbiContextMenu.attachContextMenu(contextMenuOptions);*/

              //The If condition is fire the charafterload event only once - Fix 1200
              if (!isLoad) {
                that.fireEvent('chartafterload');
                isLoad = true;
              }

              if (that.creditsenabled() === true) {
                this.credits.element.onclick = function() {
                  window.open(that.creditshref(), '_blank'  // <- This is what makes it open in a new window.
  );
                };
              }
            },

            selection: function(e) {
              var retVal =  lassoObj.selectPointsByDrag.call(this,e,that);
              if (this.lasso == 'lasso' || this.lasso == 'rlasso') {
                that.fireEvent('chartonpointclick');
              }else {
                if(e.xAxis){that.fireEvent('chartonselect');} //disabling the fireEvent while zoom out.
              }

              return retVal;
            }
          },
          ignoreHiddenSeries: that.ignorehiddenseries(),
          marginBottom: that.chartmarginbottom() == 'auto' ? null : Number(that.chartmarginbottom()),
          marginLeft: that.chartmarginleft() == 'auto' ? null : Number(that.chartmarginleft()),
          marginRight: that.chartmarginright() == 'auto' ? null : Number(that.chartmarginright()),
          marginTop: that.chartmargintop() == 'auto' ? null : Number(that.chartmargintop()),
          spacingBottom: that.chartpaddingbottom() == 'auto' ? null : Number(that.chartpaddingbottom()),
          spacingLeft: that.chartpaddingleft() == 'auto' ? null : Number(that.chartpaddingleft()),
          spacingRight: that.chartpaddingright() == 'auto' ? null : Number(that.chartpaddingright()),
          spacingTop: that.chartpaddingtop() == 'auto' ? null : Number(that.chartpaddingtop()),
          pinchType: that.chartpinchtype(),
          zoomType: that.chartzoomtype(),
          panning: true,
          panKey: that.chartpankey(),
          plotShadow: that.plotshadow(),
          reflow: that.chartflow() || false,
          shadow: that.chartshadow(),
          showaxes: that.showaxes(),
          resetZoomButton: {
            position: {
              align: that.zoombuttonalign(),
              verticalAlign: that.zoombuttonverticalalign()
            },
            theme: {
              fill: that.resetzoombuttonbackgroundcolor(),
              r: that.resetzoombuttonradius(),
              style: {color: that.resetzoombuttontextcolor()},
              states: {
                hover: {
                  fill: that.resetzoombuttonhoverbackgroundcolor(),
                  style: {color: that.resetzoombuttonhovertextcolor()}
                }
              }
            }
          },
          backgroundColor: that.chartbackgroundcolor(),
          borderColor: that.chartbordercolor(),
          borderRadius: that.chartborderradius(),
          borderWidth: that.chartborderwidth(),
          plotBackgroundColor: that.plottransparency() === true ? 'transparent' : that.plotbackgroundcolor(),
          plotBackgroundImage: that.plotbackgroundimage().replace(/ /g, ''),
          plotBorderColor: that.plotbordercolor(),
          plotBorderWidth: that.plotborderwidth(),
          selectionMarkerFill: that.zoomselectionareabackgroundcolor()
        },
        title: {
          align: that.titlealign(),
          floating: that.titlefloating(),
          margin: that.titlemargin(),
          text: that.titletext(),
          x: that.titlex() === '' ? null : that.titlex(),
          y: that.titley() === '' ? null : that.titley(),
          verticalAlign: that.titleverticalalign() === 'auto' ? null : that.titleverticalalign(),
          style: {
            color: that.titlecolor(),
            fontWeight: that.titlefontweight(),
            textDecoration: that.titlefontweight(),
            fontSize: that.titlefontsize() + 'px',
            fontFamily: that.titlefontfamily(),
            display: that.titleenable() === true ? 'block' : 'none'
          }
        },
        subtitle: {
          align: that.subtitlealign(),
          floating: that.subtitlefloating(),
          text: that.subtitletext(),
          x: that.subtitlex() === '' ? null : that.subtitlex(),
          y: that.subtitley() === '' ? null : that.subtitley(),
          verticalAlign: that.subtitleverticalalign() === 'auto' ? null : that.subtitleverticalalign(),
          style: {
            color: that.subtitlecolor(),
            fontWeight: that.subtitlefontweight(),
            textDecoration: that.subtitlefontweight(),
            fontSize: that.subtitlefontsize() + 'px',
            fontFamily: that.subtitlefontfamily(),
            display: that.subtitleenable() === true ? 'block' : 'none'
          }
        },
        credits: {
          enabled: that.creditsenabled(),
          href: that.creditshref(),
          position: {
            align: that.creditsalign(),
            verticalAlign: that.creditsverticalalign(),
            x: that.creditsxposition(),
            y: that.creditsyposition()
          },
          text: that.creditstext(),
          style: {
            color: that.creditstextcolor(),
            fontSize: that.creditsfontsize() + 'px',
            fontFamily: that.creditsfontfamily(),
            fontWeight: that.creditsfontweight(),
            cursor: that.creditscursor()
          }
        },
        exporting: {
          buttons: {
            contextButton: {
              enabled: isExportEnable,
              align: that.exportingsymbolalign(),
              verticalAlign: that.exportingsymbolverticalalign(),
              symbol: that.exportingsymbol(),
              //symbol:'url(http://upload.wikimedia.org/wikipedia/commons/0/0c/White_and_yellow_flower.JPG)',
              symbolFill: that.exportingsymbolfill(),
              symbolSize: that.exportingsymbolsize(),
              symbolStroke: that.exportingsymbolstroke(),
              symbolStrokeWidth: that.exportingsymbolstrokewidth(),
              height: that.exportingsymbolheight() == 'auto' ? 20 : _.parseInt(that.exportingsymbolheight()),
              width: that.exportingsymbolwidth() == 'auto' ? 24 : _.parseInt(that.exportingsymbolwidth()),
              symbolX: that.exportingsymbolxposition() == 'auto' ? 12 : _.parseInt(that.exportingsymbolxposition()),
              symbolY: that.exportingsymbolyposition() == 'auto' ? 10 : _.parseInt(that.exportingsymbolyposition()),
              x: that.exportingxposition() == 'auto' ? 0 : _.parseInt(that.exportingxposition()),
              y: that.exportingyposition() == 'auto' ? 0 : _.parseInt(that.exportingyposition()),
              menuItems: that.chartthemeenabled() ? Highcharts.getOptions().exporting.buttons.contextButton.menuItems : Highcharts.getOptions().exporting.buttons.contextButton.menuItems.slice(0, 10),
              theme: {
                r: that.exportingsymbolradius(),
                fill: that.exportingsymbolbackgroundfill() === '' ? null : that.exportingsymbolbackgroundfill(),
                states: {hover: {fill: that.exportingsymbolhoverbackgroundfill()}}
              }
            }
          },
          filename: that.exportedfilename(),
          sourceWidth: that.exportedchartwidth(),
          sourceHeight: that.exportedchartheight(),
          scale: that.exportedchartscale()
        },
        navigation: {
          menuStyle: {background: that.exportingmenustylebackgroundcolor()},
          menuItemStyle: {
            color: that.exportingmenuitemstyletextcolor(),
            fontWeight: that.exportingmenuitemstylefontweight(),
            textDecoration: that.exportingmenuitemstylefontweight()
          },
          menuItemHoverStyle: {
            background: that.exportingmenuitemhoverstylebackgroundcolor(),
            color: that.exportingmenuitemhoverstyletextcolor(),
            fontWeight: that.exportingmenuitemhoverstylefontweight(),
            textDecoration: that.exportingmenuitemhoverstylefontweight()
          }
        },
        xAxis: {
          categories: [
            'Measure 1',
            'Measure 2',
            'Measure 3',
            'Measure 4',
            'Measure 5'
          ],
          //type:"category",
          allowDecimals: that.xaxisallowdecimals(),
          alternateGridColor: that.xaxisalternategridcolor(),
          gridLineColor: that.xaxisgridlinecolor(),
          gridLineDashStyle: that.xaxisgridlinedashstyle(),
          gridLineWidth: that.xaxisgridlinewidth(),
          gridZIndex: that.xaxisgridzindex(),
          ceiling: that.xaxisceiling() === '' ? null : _.parseInt(that.xaxisceiling()),
          floor: that.xaxisfloor() === '' ? null : _.parseInt(that.xaxisfloor()),
          lineColor: that.xaxislinecolor(),
          lineWidth: that.xaxislinewidth(),
          minRange: that.xaxisminrange(),
          min: function() {
            if (that.xaxismin() === '' || that.xaxismin() === null || isNaN(parseFloat(that.xaxismin()))) {
              return null;
            } else if (that.xaxisminval() === 0) {
              return parseFloat(that.xaxismin());
            } else if (parseFloat(that.xaxismin()) >= that.xaxisminval() && parseFloat(that.xaxismin()) < that.xaxismaxval()) {
              return parseFloat(that.xaxismin());
            }

            return null;
          }(),
          //that.xaxismin() == '' ? null : _.parseInt(that.xaxismin()),
          max: function() {
            if (that.xaxismax() === '' || that.xaxismax() === null || isNaN(parseFloat(that.xaxismax()))) {
              return null;
            } else if (that.xaxismaxval() === 0) {
              return parseFloat(that.xaxismax());
            } else if (parseFloat(that.xaxismax()) <= that.xaxismaxval() && parseFloat(that.xaxismax()) > that.xaxisminval()) {
              return parseFloat(that.xaxismax());
            }

            return null;
          }(),
          //that.xaxismax() == ''? null : _.parseInt(that.xaxismax()),
          maxPadding: that.xaxismaxpadding() === '' ? null : parseFloat(that.xaxismaxpadding()),
          minPadding: that.xaxisminpadding() ==='' ? null : parseFloat(that.xaxisminpadding()),
          opposite: that.xaxisopposite(),
          offset: that.xaxisoffset(),
          reversed: that.xaxisreversed() === true,
          showEmpty: that.xaxisshowempty(),
          showFirstLabel: that.xaxisshowfirstlabel(),
          showLastLabel: that.xaxisshowlastlabel(),
          dateTimeLabelFormats: {},
          minTickInterval: that.xaxismintickinterval(),
          tickColor: that.xaxistickcolor(),
          tickInterval: that.xaxistickinterval(),
          tickLength: that.xaxisticklength(),
          tickPosition: that.xaxistickposition(),
          tickWidth: that.xaxistickwidth(),
          tickmarkPlacement: that.xaxistickmarkplacement(),
          labels: {
            align: that.xaxislabelalign(),
            enabled: that.xaxislabelenabled(),
            format: that.xaxislabelprefix() + that.xaxislabelformat() + that.xaxislabelsuffix(),
            //overflow:that.xaxislabeloverflow(),
            rotation: that.xaxislabelrotation(),
            //distance:that.xaxislabeldistance(),
            staggerLines: that.xaxislabelstaggerline() === '' ? null : _.parseInt(that.xaxislabelstaggerline()),
            maxStaggerLines: that.xaxislabelmaxstaggerline() === '' ? null : _.parseInt(that.xaxislabelmaxstaggerline()),
            step: that.xaxislabelstep() === 0 ? null : that.xaxislabelstep(),
            x: that.xaxislabelx(),
            y: that.xaxislabely(),
            zIndex: that.xaxislabelzindex(),
            style: {
              color: that.xaxislabelcolor(),
              fontWeight: that.xaxislabelfontweight(),
              textDecoration: that.xaxislabelfontweight(),
              fontSize: that.xaxislabelfontsize() + 'px',
              fontFamily: that.xaxislabelfontfamily()
            },
            events: {
              click: function () {
                seriesLibrary.axisClickEvent(this,that);
              }
            }
          },
          title: {
            text: that.xaxistitletext(),
            align: that.xaxistitlealign(),
            rotation: that.xaxistitlerotation(),
            offset: offsetaxis(that.xaxistitleenabled(), that.xaxistitleoffset(), that.xaxistitletext()),
            margin: that.xaxistitlemargin(),
            style: {
              color: that.xaxistitlecolor(),
              fontWeight: that.xaxistitlefontweight(),
              textDecoration: that.xaxistitlefontweight(),
              fontSize: that.xaxistitlefontsize() + 'px',
              fontFamily: that.xaxistitlefontfamily(),
              display: that.xaxistitleenabled() === true ? 'block' : 'none'
            }
          },
          plotBands: [{
              color: that.xaxisplotbandenabled() === true ? that.xaxisplotbandcolor() : null,
              borderColor: that.xaxisplotbandenabled() === true ? that.xaxisplotbandbordercolor() : null,
              borderWidth: that.xaxisplotbandborderwidth(),
              from: that.xaxisplotbandfrom(),
              to: that.xaxisplotbandto(),
              zIndex: that.xaxisplotbandzindex(),
              events: {
                click: function(/*event*/) {
                  that.fireEvent('xaxisplotbandonclick');
                },

                mouseover: function(/*e*/) {
                  that.fireEvent('xaxisplotbandmousemove');
                }
              },
              label: {
                style: {
                  color: that.xaxisplotbandlabelcolor(),
                  fontWeight: that.xaxisplotbandlabelfontweight(),
                  textDecoration: that.xaxisplotbandlabelfontweight(),
                  fontSize: that.xaxisplotbandlabelfontsize() + 'px',
                  fontFamily: that.xaxisplotbandlabelfontfamily(),
                  display: that.xaxisplotbandlabelenabled() === true ? 'block' : 'none'
                },
                text: that.xaxisplotbandlabeltext(),
                align: that.xaxisplotbandlabelalign(),
                rotation: that.xaxisplotbandlabelrotation(),
                textAlign: that.xaxisplotbandlabeltextalign(),
                verticalAlign: that.xaxisplotbandlabelverticalalign(),
                x: that.xaxisplotbandlabelxposition() === '' ? null : _.parseInt(that.xaxisplotbandlabelxposition()),
                y: that.xaxisplotbandlabelyposition() === '' ? null : _.parseInt(that.xaxisplotbandlabelyposition())
              }
            }],
          plotLines: [{
              color: that.xaxisplotlineenabled() === true ? that.xaxisplotlinecolor() : null,
              dashStyle: that.xaxisplotlinedashstyle(),
              width: that.xaxisplotlinewidth(),
              value: that.xaxisplotlinevalue(),
              zIndex: that.xaxisplotlinezindex(),
              label: {
                style: {
                  color: that.xaxisplotlinelabelcolor(),
                  fontWeight: that.xaxisplotlinelabelfontweight(),
                  textDecoration: that.xaxisplotlinelabelfontweight(),
                  fontSize: that.xaxisplotlinelabelfontsize() + 'px',
                  fontFamily: that.xaxisplotlinelabelfontfamily(),
                  display: that.xaxisplotlinelabelenabled() === true ? 'block' : 'none'
                },
                text: that.xaxisplotlinelabeltext(),
                align: that.xaxisplotlinelabelalign(),
                rotation: that.xaxisplotlinelabelrotation(),
                textAlign: that.xaxisplotlinelabeltextalign(),
                verticalAlign: that.xaxisplotlinelabelverticalalign(),
                x: that.xaxisplotlinelabelxposition() == 'null' ? null : _.parseInt(that.xaxisplotlinelabelxposition()),
                y: that.xaxisplotlinelabelyposition() == 'null' ? null : _.parseInt(that.xaxisplotlinelabelyposition())
              }
            }]
        },
        yAxis: {
          allowDecimals: that.yaxisallowdecimals(),
          alternateGridColor: that.yaxisalternategridcolor(),
          gridLineColor: that.yaxisgridlinecolor(),
          gridLineDashStyle: that.yaxisgridlinedashstyle(),
          gridLineWidth: that.yaxisgridlinewidth(),
          gridZIndex: that.yaxisgridzindex(),
          lineColor: that.yaxislinecolor(),
          lineWidth: that.yaxislinewidth(),
          minorGridLineColor: that.yaxisminorgridlinecolor(),
          minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
          minorGridLineWidth: that.yaxisminorgridlinewidth(),
          minorTickColor: that.yaxisminortickcolor(),
          minorTickInterval: that.yaxisminortickinterval() === '' ? 'auto' : _.parseInt(that.yaxisminortickinterval()),
          minorTickLength: that.yaxisminorticklength(),
          minorTickPosition: that.yaxisminortickposition(),
          minorTickWidth: that.yaxisminortickwidth(),
          tickColor: that.yaxistickcolor(),
          tickInterval: that.yaxistickinterval() === '' ? null : _.parseInt(that.yaxistickinterval()),
          tickLength: that.yaxisticklength(),
          tickPosition: that.yaxistickposition(),
          tickWidth: that.yaxistickwidth(),
          tickmarkPlacement: that.yaxistickmarkplacement(),
          dateTimeLabelFormats: {},
          ceiling: that.yaxisceiling() === '' ? null : _.parseInt(that.yaxisceiling()),
          floor: that.yaxisfloor() === '' ? null : _.parseInt(that.yaxisfloor()),
          min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
          max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
          maxPadding: that.yaxismaxpadding() === '' ? null : parseFloat(that.yaxismaxpadding()),
          minPadding: that.yaxisminpadding() === '' ? null : parseFloat(that.yaxisminpadding()),
          minRange: that.yaxisminrange(),
          offset: that.yaxisoffset(),
          opposite: that.yaxisopposite(),
          reversed: that.yaxisreversed() === true,
          showEmpty: that.yaxisshowempty(),
          showFirstLabel: that.yaxisshowfirstlabel(),
          showLastLabel: that.yaxisshowlastlabel(),
          //          startOnTick: that.yaxisstartontick(),
          //          endOnTick: that.yaxisendontick(),
          title: {
            text: that.yaxistitletext(),
            align: that.yaxistitlealign(),
            rotation: that.yaxistitlerotation(),
            offset: offsetaxis(that.yaxistitleenabled(), that.yaxistitleoffset(), that.yaxistitletext()),
            margin: that.yaxistitlemargin(),
            style: {
              color: that.yaxistitlecolor(),
              fontWeight: that.yaxistitlefontweight(),
              textDecoration: that.yaxistitlefontweight(),
              fontSize: that.yaxistitlefontsize() + 'px',
              fontFamily: that.yaxistitlefontfamily(),
              display: that.yaxistitleenabled() === true ? 'block' : 'none'
            }
          },
          labels: {
            align: that.yaxislabelalign(),
            enabled: that.yaxislabelenabled(),
            formatter: function(){
              return vbiHighchartsDefault['Yaxis_autoscale_formatter'](that,this);
            },
            /*formatter: function() {
              return that.yaxislabelprefix() + ' ' + Highcharts.numberFormat(this.value, that.decimal(), that.bulletdecimalseparator(), that.bulletthousandseparator()) + ' ' + that.yaxislabelsuffix();
            },*/

            rotation: that.yaxislabelrotation(),
            staggerLines: that.yaxislabelstaggerline() === '' ? null : _.parseInt(that.yaxislabelstaggerline()),
            maxStaggerLines: that.yaxislabelmaxstaggerline() === '' ? null : _.parseInt(that.yaxislabelmaxstaggerline()),
            step: that.yaxislabelstep() === 0 ? null : that.yaxislabelstep(),
            x: that.yaxislabelx(),
            y: that.yaxislabely(),
            zIndex: that.yaxislabelzindex(),
            style: {
              color: that.yaxislabelcolor(),
              fontWeight: that.yaxislabelfontweight(),
              textDecoration: that.yaxislabelfontweight(),
              fontSize: that.yaxislabelfontsize() + 'px',
              fontFamily: that.yaxislabelfontfamily()
            },
            events: {
              click: function () {
                seriesLibrary.axisClickEvent(this,that);
              }
            }
          },
          plotBands: [{
              color: that.yaxisplotbandenabled() === true ? that.yaxisplotbandcolor() : null,
              borderColor: that.yaxisplotbandenabled() === true ? that.yaxisplotbandbordercolor() : null,
              borderWidth: that.yaxisplotbandborderwidth(),
              from: that.yaxisplotbandfrom(),
              to: that.yaxisplotbandto(),
              zIndex: that.yaxisplotbandzindex(),
              events: {
                click: function(/*event*/) {
                  that.fireEvent('yaxisplotbandonclick');
                },

                mouseover: function(/*e*/) {
                  that.fireEvent('yaxisplotbandmousemove');
                }
              },
              label: {
                style: {
                  color: that.yaxisplotbandlabelcolor(),
                  fontWeight: that.yaxisplotbandlabelfontweight(),
                  textDecoration: that.yaxisplotbandlabelfontweight(),
                  fontSize: that.yaxisplotbandlabelfontsize() + 'px',
                  fontFamily: that.yaxisplotbandlabelfontfamily(),
                  display: that.yaxisplotbandlabelenabled() === true ? 'block' : 'none'
                },
                text: that.yaxisplotbandlabeltext(),
                align: that.yaxisplotbandlabelalign(),
                rotation: that.yaxisplotbandlabelrotation(),
                textAlign: that.yaxisplotbandlabeltextalign(),
                verticalAlign: that.yaxisplotbandlabelverticalalign(),
                x: that.yaxisplotbandlabelxposition() == 'null' ? null : _.parseInt(that.yaxisplotbandlabelxposition()),
                y: that.yaxisplotbandlabelyposition() == 'null' ? null : _.parseInt(that.yaxisplotbandlabelyposition())
              }
            }],
          plotLines: [{
              color: that.yaxisplotlineenabled() === true ? that.yaxisplotlinecolor() : null,
              dashStyle: that.yaxisplotlinedashstyle(),
              width: that.yaxisplotlinewidth(),
              value: that.yaxisplotlinevalue(),
              zIndex: that.yaxisplotlinezindex(),
              label: {
                style: {
                  color: that.yaxisplotlinelabelcolor(),
                  fontWeight: that.yaxisplotlinelabelfontweight(),
                  textDecoration: that.yaxisplotlinelabelfontweight(),
                  fontSize: that.yaxisplotlinelabelfontsize() + 'px',
                  fontFamily: that.yaxisplotlinelabelfontfamily(),
                  display: that.yaxisplotlinelabelenabled() === true ? 'block' : 'none'
                },
                text: that.yaxisplotlinelabeltext(),
                align: that.yaxisplotlinelabelalign(),
                rotation: that.yaxisplotlinelabelrotation(),
                textAlign: that.yaxisplotlinelabeltextalign(),
                verticalAlign: that.yaxisplotlinelabelverticalalign(),
                x: that.yaxisplotlinelabelxposition() == 'null' ? null : _.parseInt(that.yaxisplotlinelabelxposition()),
                y: that.yaxisplotlinelabelyposition() == 'null' ? null : _.parseInt(that.yaxisplotlinelabelyposition())
              }
            }]
        },
        loading: {
          labelStyle: {
            fontSize: '18px',
            fontWeight: loadingfont[0],
            fontStyle: loadingfont[1],
            color: that.loadingcolor()
          },
          style: {
            backgroundColor: that.loadingstylebackgroundcolor(),
            opacity: Number(that.loadingopacity()),
            textAlign: that.loadingtextalign()
          }
        },
        tooltip: {
          animation: that.tooltipanimation() || false,
          crosshairs: that.tooltipcrosshair(),
          enabled: that.tooltipenable(),
          folowPointer: that.tooltipfollowpointer(),
          followTouchMove: that.tooltipfollowtouchmove(),
          hideDelay: that.tooltiphidedelay(),
          shadow: that.tooltipshadow(),
          shape: that.tooltipshape(),
          //shared: that.tooltipshared(),
          snap: that.tooltipsnap(),
          valueDecimals: that.tooltipvaluedecimals(),
          valuePrefix: that.tooltipvalueprefix(),
          valueSuffix: that.tooltipvaluesuffix(),
          backgroundColor: that.tooltipbackgroundcolor(),
          borderColor: that.tooltipbordercolor(),
          borderRadius: that.tooltipborderradius(),
          borderWidth: that.tooltipborderwidth(),
          //  formatter : function() {
          //    return seriesLibrary.barFamilyTooltip(this,that,that.tooltipdecimalseparator(),that.tooltipthousandseparator());
          //  },
          style: {
            color: that.tooltipcolor(),
            fontWeight: that.tooltipfontweight(),
            textDecoration: that.tooltipfontweight(),
            fontSize: that.tooltipOverlap(),
            fontFamily: that.tooltipfontfamily()
          },
          useHTML: true,
          headerFormat: '<span style="font-size: ' + that.tooltipOverlap() + '">{point.key}</span><br/>'
          // headerFormat: '<p style="font-size:'+ that.tooltipfontsize() == 'auto' ? that.tooltipOverlap()+'px' : that.tooltipfontsize()+'px'+'">{point.key}</p>',
         /* positioner: function(labelWidth, labelHeight, point) {
            var tooltipX, tooltipY, bulletchart = this.chart;
            if (point.plotX + labelWidth > bulletchart.plotWidth) {
              tooltipX = point.plotX + bulletchart.plotLeft - labelWidth + 15;
            } else {
              tooltipX = point.plotX + bulletchart.plotLeft - 15;
            }

            //tooltipY = point.plotY + bulletchart.plotTop - labelHeight * 1.5;
            tooltipY = point.plotY + bulletchart.plotTop - 15;
          //  console.log(tooltipY + "--" + bulletchart.plotTop + "--" + point.plotY + "--" + labelHeight * 1.5);
           /* if (tooltipY < bulletchart.plotTop) {
              tooltipY += labelHeight * 1.5;
            }
          */
           /*if(tooltipY > labelHeight) {
              tooltipY -= labelHeight * 1.2;
            }*/

          /*  return {
              x: tooltipX,
              y: tooltipY
            };
          }*/
        },
        plotOptions: {
          bar: {
            grouping: false,
            shadow: false,
            borderWidth: 0,
            pointPadding: 0.25,
            groupPadding: 0,
            dataLabels: {style: {textShadow: false}}
          },
          column: {
            grouping: false,
            shadow: false,
            borderWidth: 0,
            pointPadding: 0.25,
            groupPadding: 0,
            dataLabels: {style: {textShadow: false}}
          },
          scatter:{
            threshold : 0
          },
          series: {
            cursor: 'pointer',
            stickyTracking: false,
            //turboThreshold:0,
            point: {
              events: {
                click: function(event) {
                  try {
                    //that.selectedvalue(seriesLibrary.createMemberData(that, that.categoriesIndex[event.point.index], event.point.series.options.key));  //changed = 1;
                    /**
                     * VBX141-4886 : Change has been done to accommodate scripting with Individual Scale. In bullet chart with Individual Scaling enabled,
                     *               event.point.index is always equal to 0 as each bullet is a separate chart.
                     */
                    that.selectedvalue(seriesLibrary.createMemberData(that, event.point.rowIndex, event.point.series.options.key));
                  } catch (e) {   seriesLibrary.DSXalert(e.message);
                  }
                },

                select: function(event) {
                  if (!this.series.chart.lassoFlag) {
                    try {
                      if (that.chartenablezoom()){
                        that.selectedPoints = $('#detail-container' + that['id']()).highcharts().getSelectedPoints();
                      }
                      else{
                        /**
                         * VBX141-4886 : When "Enable Individual Scale" is set, each of the bullets in a bullet chart is rendered using there own container div.
                         *               Hence with Individual Scale enabled, component.highcharts() does not give reference to highcharts object.
                         *               Following solution works in all scenarios.
                         */
                        that.selectedPoints = this.series.chart.getSelectedPoints(); //component.highcharts().getSelectedPoints();
                      }
                      that.selectedPoints.push(this);

                      if(that.individualscale()){
                        var isMultiSelection = event.accumulate;
                        selectedBullet = true; // global variable to let us know if the unselect is called programatically.
                        /**
                         * VBX141-4887 : If "Individual Scale" is enabled and shift key is not pressed then avoid multiselection
                         */
                        if(isMultiSelection){
                          _.each(that.neighbourBullets, function(eachBullet){
                            that.selectedPoints = that.selectedPoints.concat(eachBullet.getSelectedPoints());
                          });
                        }
                        else{
                          suppressUnselectCall = true;
                          _.each(that.neighbourBullets, function(eachBullet){
                            var point = eachBullet.getSelectedPoints()[0];
                            if(point && point.selected){
                              point.select(false);
                            }
                          });
                          suppressUnselectCall = false;
                        }

                        // Done this way to avoid lot of changes.
                        var members = [];
                        var member;
                        for(var i=that.selectedPoints.length-1; i>=0; i--){
                          if(typeof that.selectedPoints[i].rowIndex !== "undefined"){
                            member = seriesLibrary.createMembersData(that, [that.selectedPoints[i].rowIndex], [that.selectedPoints[i]]);
                            members.push(member[0]);
                          }
                        }
                        that.selectedvalues(members.toString());
                      }
                      else
                      {
                        that.selectedvalues(seriesLibrary.createMembersData(that, that.categoriesIndex, that.selectedPoints).toString());
                      }
                      seriesLibrary.onSelectFunction(that);
                    } catch (e) {   seriesLibrary.DSXalert(e.message);
                    }

                    /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
                  }
                },

                unselect: function() {
                  if (!this.series.chart.lassoFlag && !suppressUnselectCall) {
                    try {
                       
                        if (that.chartenablezoom()){
                            that.selectedPoints = $('#detail-container' + that['id']() + '').highcharts().getSelectedPoints();
            }
            else if(that.individualscale()){
              that.selectedPoints =[];
              _.each(that.neighbourBullets, function(eachBullet){
                  that.selectedPoints = that.selectedPoints.concat(eachBullet.getSelectedPoints());
                });
            }
                        else{
                            that.selectedPoints = this.series.chart.getSelectedPoints(); //component.highcharts().getSelectedPoints();
                        }

                        var index = that.selectedPoints.indexOf(this);
                        if (index > -1) {
                            that.selectedPoints.splice(index, 1);
            }
            var members = [];
            if(that.individualscale()){
               // Done this way to avoid lot of changes
              var member;
              for(var i=that.selectedPoints.length-1; i>=0; i--){
                if(typeof that.selectedPoints[i].rowIndex !== "undefined"){
                  member = seriesLibrary.createMembersData(that, [that.selectedPoints[i].rowIndex], [that.selectedPoints[i]]);
                  members.push(member[0]);
                }
              }
            }
            else
            {
              members = seriesLibrary.createMembersData(that, that.categoriesIndex, that.selectedPoints);
            }
                        that.selectedvalues(members.toString());
                        if(that.selectedvalues() === ""){
                            that.selectedvalue('');
                        }else{
                            that.selectedvalue(members[0]);
                        }
                        /**
                         *Selectedvalue fix in all charts
                         *Multiple Selection getting the last selected value.
                        **/
                        if(that.clearSelect){
                            if(that.selectedvalues() === ""){
                                that.clearSelect = false;
                            }
                        }
                        else{
                                seriesLibrary.onSelectFunction(that);
                            }//clearselection callback issue on Onselect.
                    }
                    catch (e) {
                        seriesLibrary.DSXalert(e.message);
                    }
                 }
               }
              }
            },
            allowPointSelect: that.allowpointselect(),
            connectNulls: that.connectnulls(),
            cropThreshold: that.cropthreshold(),
            turboThreshold: that.turbothreshold(),
            marker: {}
          }
        },
        legend: {enabled: false},
        series: options.seriesData
      };
      return defaultValue;
  }

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.measureValidation = function() {
      var returnValue = false;
      var measureinrow = false;
      try {
        for (var i = 0; i < component.result().dimensions.length; i++) {
          if (component.result().dimensions[i].containsMeasures === true && component.result().dimensions[i].axis == 'ROWS') {
            measureinrow = true;
          }
        }

        if (measureinrow === true) {
          returnValue = false;
        } else {
          returnValue = true;
        }  //return true;
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return returnValue + '';  //callruntime handler won't handle object and boolean hence return string
    };

    component.getDataSeries = function() {
    if (!component.dataRes) { return null; }
      var dataSeries = [];
      //component.dataRes = component.dispKeyTextResultSet();
      var bulletDefaultColor = ['#000000'];
      var seriesColor = [];
      var rowDimensions = {};
      var selectedRowdim = [];
      var bardatacustomizationJson = {
        'COLUMNS': [],
        'ROWS': []
      };
      if (component.bardatacustomization() !== '') {
        bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
      }

      try {
        if (component.dataRes === undefined || component.dataRes === '') {
          return null;
        }

        var measureDimensionIndex = seriesLibrary.getMeasureDimensionIndex(component);
        if (JSON.stringify(component.dataRes.dimensions).indexOf('containsMeasures') == -1) {
          return null;
        } else if (JSON.stringify(component.dataRes.dimensions).indexOf('containsMeasures') != -1 && component.dataRes.dimensions[measureDimensionIndex].members.length < 2) {
          return null;
        } else if (component.dataRes.dimensions.length < 2) {
          if (component.dataRes.dimensions.length == 1 && component.dataRes.dimensions[0].axis == 'COLUMNS' && component.dataRes.dimensions[0].containsMeasures === true && component.dataRes.dimensions[0].members.length >= 2) {
            var seriesColor = [];
            if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
              seriesColor = [];
            } else {
              seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
            }

            seriesLibrary.getSeriesColors(component, seriesColor, 0, bulletDefaultColor);
            dataSeries.push('Measures');
            seriesColor.splice(dataSeries.length, seriesColor.length);
            component.dataseriescolor(seriesColor.join());
            return [
              dataSeries,
              dataSeries
            ];
          } else {
            return null;
          }
        } else if (component.dataRes['axis_columns'][0].indexOf(-1) < 1) {
          return null;
        } else if (component.datautility() === true && bardatacustomizationJson['ROWS'].length === 0) {
          if (component.dataRes['axis_columns'][0].indexOf(-1) != -1) {
            rowDimensions = seriesLibrary.getDimension(component, 'ROWS');
          }

          if (Object.keys(rowDimensions).length !== 0) {
            selectedRowdim = selectedRowdim.concat({
              'index': Object.keys(rowDimensions)[0],
              'text': rowDimensions[Object.keys(rowDimensions)[0]]
            });
            bardatacustomizationJson['ROWS'] = bardatacustomizationJson['ROWS'].concat(selectedRowdim);
            component.bardatacustomization(JSON.stringify(bardatacustomizationJson));
          }
        }
        //dataSeries = seriesLibrary.createSeriesData(component, 'bullet', defaultValueSeriesNames);
        dataSeries = component.createSeriesAdditionalProperty();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return [
        dataSeries[0],
        dataSeries[1]
      ];
    };

    component.getDataSeriesColor = function() {
      var dataseriescolor = '';
      try {
        dataseriescolor = component.dataseriescolor();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataseriescolor;
    };

    component.getDatUtility = function() {
      var datautility = '';
      try {
        datautility = component.datautility();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return datautility;
    };

    component.getChartType = function() {
      return 'bullet';
    };

    component.getMemberJson = function() {
      return component.membersJson();
    };

    component.getMeasureJson = function() {
      var measureJson = {};
      var measureNameChange = {};
      if (component.hasOwnProperty('chartmeasurechange') && component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== '' && component.chartmeasurechange() !== null) {
        measureNameChange = JSON.parse(component.chartmeasurechange());
      }
  if (component.result() !== undefined && component.result() !== '' && component.result() !== null) {
      for (var i = 0; i < component.result().dimensions.length; i++) {
        if ('containsMeasures' in component.result().dimensions[i]) {
          $.each(component.result().dimensions[i].members, function(key, value) {
            if (/*measureNameChange[value.key] !== '' &&*/ measureNameChange[value.key] !== undefined) {
              measureJson[value.key] = {
                text: measureNameChange[value.key],
                index: key
              };
            } else {
              measureJson[value.key] = {
                text: value.text,
                index: key
              };
            }
          });

          break;
        }
      }
  }

      //alert(JSON.stringify(measureJson))
      return JSON.stringify(measureJson);
    };

  component.getMeasuresNamesForFormatter = function(){
      return vbiNumberFormat.getMeasuresNamesForFormatter(component);
  };

  component.setChangedFlag = function() {
    component.changed = 1;
  };

  component.componentDeleted = function() {
    $('#dsui_' + componentID).remove();
  };

  component.getMaxRange = function() {
    return component.datamaxrange();
  };

  component.getMinRange = function() {
    return component.dataminrange();
  };

  component.getMinMaxValues = function() {
    return component.xaxisminval() + ',' + component.xaxismaxval() + ',' + component.yaxisminval() + ',' + component.yaxismaxval();
  };

  component.getQualitativeScaleColor = function(k) {
    if (k == 1) {
      return component.qualitativescale1colors();
    }

    if (k == 2) {
      return component.qualitativescale2colors();
    }

    if (k == 3) {
      return component.qualitativescale3colors();
    }
  };

  component.getResultSetInfo = function(property){
    var resultSet = component.result();
    var info = null;
    if (resultSet !== undefined && resultSet !== null && resultSet !== '' && typeof resultSet[property] !== 'undefined') {
      info = resultSet[property];
      info = typeof info === 'object' ? JSON.stringify(info) : info;
    }
    return info;
  };

  component.lassoFireProp = function(selectedPoints) {
    component.selectedvalues(seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints).toString());
    //component.changed++;
    component.firePropertiesChanged(['selectedvalues']);
  };

  //Function to avoid the tooltip overlap in bulletchart
  component.tooltipOverlap = function() {
    //check whether the fontsize is auto if so auto font size function else user defined font size
    var tooltipFontsize = component.tooltipfontsize() == 'auto' ? tooltipOverlapSize() + 'px' : component.tooltipfontsize() + 'px';
    function tooltipOverlapSize() {
      var containerWidth = $(component.owner.getDomRef()).width();
      //var containerHeight = $(component.owner.getDomRef()).height();
      var ret;
      switch (true) {
      case containerWidth === 0:
        ret = 11;
        break;
      case containerWidth <= 200:
        ret = 4;
        break;
      case containerWidth <= 300:
        ret = 6;
        break;
      case containerWidth <= 400:
        ret = 7;
        break;
      case containerWidth <= 500:
        ret = 8;
        break;
      case containerWidth <= 600:
        ret = 10;
        break;
      default:
        ret = 11;
        break;
      }
      return ret;
    }
    //console.log(tooltipFontsize);
    return tooltipFontsize;
  };

  }

}