function SemicircledonutChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        data: [
          {
            name: "Northeast",
            y: 2353233,
            color: "#7BB6EF"
          },
          {
            name: "Southeast",
            y: 1932832,
            color: "#99E395"
          },
          {
            name: "Midwest",
            y: 1732331,
            color: "#E69DB1"
          },
          {
            name: "West",
            y: 1465932,
            color: "#F8AA6B"
          },
          {
            name: "Central",
            y: 982828,
            color: "#A3A3A3"
          }
        ]
      }
    ];
    return seriesData;
  };

  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var defaultValue = {
      chart: {
        options3d: {
          alpha: that.piealpha(),
          beta: that.piebeta()
        },
        type: "pie",
        //inverted:that.chartinverted(),
        //alignTicks:that.chartalignticks(),
        animation: that.result()
          ? that.result().tuples.length > 1000 ? false : that.chartanimation()
          : that.chartanimation(),
        className: that.chartcssclassname(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        events: {
          click: function(event) {
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),

        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            relativeTo: that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      plotOptions: {
        series: {
          cursor: "pointer",
          point: {
            events: {
              click: function(event) {
                try {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  ); //that.colorChanged = 1;
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
              },

              select: function() {
                try {
                  that.selectedPoints = component
                    .highcharts()
                    .getSelectedPoints();
                  that.selectedPoints.push(this);
                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                  );
                  seriesLibrary.onSelectFunction(that);
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }

                /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
              },

              unselect: function() {
                try {
                  //var unselectedPoints = component.highcharts().getSelectedPoints();
                  var index = that.selectedPoints.indexOf(this);
                  if (index > -1) {
                    that.selectedPoints.splice(index, 1);
                  }

                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                  );
                  if (that.selectedvalues() === "") {
                    that.selectedvalue("");
                  } else {
                    var select = seriesLibrary.createMembersData(
                      that,
                      that.categoriesIndex,
                      that.selectedPoints
                    );
                    that.selectedvalue(select[0]);
                  }
                  /**
                       *Selectedvalue fix in all charts
                       *Multiple Selection getting the last selected value.
                      **/
                  if (that.clearSelect) {
                    if (that.selectedvalues() === "") {
                      that.clearSelect = false;
                    }
                  } else {
                    seriesLibrary.onSelectFunction(that);
                  } //clearselection callback issue on Onselect.
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
                /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
              }
            }
          }
        },
        pie: {
          center:
            options.chartType == "semicircle donut horizontal" ||
            options.chartType == "3d semicircle donut horizontal"
              ? ["50%", "75%"]
              : "",
          states: {
            hover: {
              enabled: that.donuthoverenable(),
              brightness: that.donuthoverbrightness()
            }
          },
          showInLegend: that.legendenable(),
          size: that.donutsize(),
          slicedOffset: that.donutsliceoffset(),
          borderColor: that.piebordercolor(),
          borderWidth: that.pieborderwidth(),
          allowPointSelect: that.allowpointselect(),
          cursor: that.pointcursor(),
          enableMouseTracking: that.enablemousetracking(),
          lineWidth: that.linewidth(),
          turboThreshold: that.turbothreshold(),
          shadow: that.seriesshadow(),
          point: {
            events: {
              click: function() {
                that.fireEvent("pointclick");
              }
            }
          },
          dataLabels: {
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            distance: Number(that.datalabeldistance()),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            x: that.datalabelx(),
            y: that.datalabely(),
            /*  formatter: function () {
  eturn that.datalabelprefix()+''+Highcharts.numberFormat(this.y,that.datavaluedecimals())+''+that.datalabelsuffix();
  */
            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() === true
                  ? this.fontfamily()
                  : that.datalabelfontfamily()
            }
          }
        }
      },
      series: options.seriesData
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.getMeasureMembersKeyAndText = function() {
    var measureMemberKeys = [];
    var measureMemberText = [];
    if (component.dataRes !== undefined && component.dataRes !== '') {
      try {
        var mesIndex = component.getMeasureIndex();
        for (var i = 0; i < component.dataRes.dimensions[mesIndex].members.length; i++) {
          measureMemberKeys.push(component.dataRes.dimensions[mesIndex].members[i].key);
          measureMemberText.push(component.dataRes.dimensions[mesIndex].members[i].picker_text);// jshint ignore:line
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }
    }

    return [
      measureMemberText,
      measureMemberKeys
    ];
  };

  component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
    return seriesLibrary.getDataSeries(component, 'pie');
  };

  component.getDataSeriesColor = function() {
    return component.dataseriescolor();
  };

  component.getMeasureMembers = function() {
    return seriesLibrary.getMeasureMembers(component);
  };

  component.getChartType = function() {
    return 'pie';
  };

  component.getDimensionList = function() {
    // var dimlist =[];
    var dimensions = [];
    if (component.result() !== undefined && component.result() !== '') {
      try {
        for (var i = 0; i < component.result().dimensions.length; i++) {
          dimensions.push(component.result().dimensions[i].text);
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }
    }

    return dimensions;
  };

  component.getChartFamily = function() {
    return 'pie';
  };

  component.componentDeleted = function() {
    $('#dsui_' + componentID).remove();
  };

  }
}