function SolidGaugeChartUtil(){
  componentUtil.call(this);

  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset === "" || titletext === " ") {
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };

    //resolving ternaries here *phew*
    var tmarginBottom = null;
    var tmarginLeft = null;
    var tmarginRight = null;
    var tmarginTop = null;
    var tspacingBottom = null;
    var tspacingLeft = null;
    var tspacingRight = null;
    var tspacingTop = null;

    var tplotBackgroundColor = that.plotbackgroundcolor();
    var tdisplay = "none";
    var tbackgroundColor = that.datalabelbackgroundcolor();
    var tfontFamily = that.datalabelfontfamily();
    var tminorTickInterval = that.yaxisminortickinterval();
    var maximumNumber = that.maximumvalue();
    if (that.chartmarginbottom() !== "auto") {
      tmarginBottom = _.parseInt(that.chartmarginbottom(), 10);
    }

    if (that.chartmarginleft() !== "auto") {
      tmarginLeft = _.parseInt(that.chartmarginleft(), 10);
    }

    if (that.chartmarginright() !== "auto") {
      tmarginRight = _.parseInt(that.chartmarginright(), 10);
    }

    if (that.chartmargintop() !== "auto") {
      tmarginTop = _.parseInt(that.chartmargintop(), 10);
    }

    if (that.chartpaddingbottom() !== "auto") {
      tspacingBottom = _.parseInt(that.chartpaddingbottom(), 10);
    }

    if (that.chartpaddingleft() !== "auto") {
      tspacingLeft = _.parseInt(that.chartpaddingleft(), 10);
    }

    if (that.chartpaddingright() !== "auto") {
      tspacingRight = _.parseInt(that.chartpaddingright(), 10);
    }

    if (that.chartpaddingtop() !== "auto") {
      tspacingTop = _.parseInt(that.chartpaddingtop(), 10);
    }

    if (that.plottransparency() === true) {
      tplotBackgroundColor = "transparent";
    }

    if (that.yaxisminortickinterval() === " ") {
      tminorTickInterval = 0;
    }

    if (that.yaxistitleenabled() === true) {
      tdisplay = "block";
    }

    if (that.datalabelbackgroundcolor() === "") {
      tbackgroundColor = null;
    }

    if (that.globalfont() === true) {
      tfontFamily = that.fontfamily();
    }

    //Default Values of the chart
    var defaultValue = {
      chart: {
        type: "solidgauge",
        alignTicks: that.chartalignticks(),
        animation: that.chartanimation(),
        className: that.chartclassname(),
        events: {
          click: function() {
            that.fireEvent("chartonclick");
          },

          load: function() {
            /*var contextMenuOptions={event:event, 
                          enableContextMenu:that.enableContextMenu(), 
                          enableDisplayDataButton:that.enableDisplayDataButton(), 
                          enableMaximizeButton:that.enableMaximizeButton(), 
                          enableMoreActionsButton:that.enableMoreActionsButton()}; 

    //The If condition is fire the charafterload event only once - Fix 1200 
    vbiContextMenu.attachContextMenu(contextMenuOptions);*/

            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              that.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom: tmarginBottom,
        marginLeft: tmarginLeft,
        marginRight: tmarginRight,
        marginTop: tmarginTop,
        spacingBottom: tspacingBottom,
        spacingLeft: tspacingLeft,
        spacingRight: tspacingRight,
        spacingTop: tspacingTop,
        plotShadow: that.plotshadow(),
        reflow: that.chartflow(),
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            relativeTo: that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: {
              color: that.resetzoombuttontextcolor()
            },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: {
                  color: that.resetzoombuttonhovertextcolor()
                }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor: tplotBackgroundColor,
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      pane: {
        background: {
          backgroundColor: that.solidGaugeTrackColor(),
          innerRadius: "60%",
          outerRadius: "100%",
          shape: "arc"
        },
        center: ["50%", "85%"],
        endAngle: 90,
        size: "100%",
        startAngle: -90
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      yAxis: {
        zIndex: 50,
        min: Number(that.minimumvalue()),
        max: Number(maximumNumber),
        title: {
          text: that.yaxistitletext(),
          useHTML: true,
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            zIndex: 999,
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: tdisplay
          }
        },
        stops: [[0.1, that.gaugecolorpicker()]],
        labels: {
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          format:
            that.yaxislabelprefix() + "{value:,.0f}" + that.yaxislabelsuffix(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          }
        },
        tickColor: that.yaxistickcolor(),
        tickInterval: parseFloat(that.yaxistickinterval()),
        tickLength: that.yaxisticklength(),
        tickPosition: that.yaxistickposition(),
        tickWidth: that.yaxistickwidth(),
        tickmarkPlacement: that.yaxistickmarkplacement(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval: tminorTickInterval,
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth()
      },
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      plotOptions: {
        solidgauge: {
          events: {
            click: function() {
              that.fireEvent("chartonpointclick");
            }
          },
          dataLabels: {
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: false,
            backgroundColor: tbackgroundColor,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            //padding:that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign:
              that.datalabelverticalalign() === "top"
                ? "bottom"
                : that.datalabelverticalalign() === "bottom" ? "top" : "middle", //jshint ignore:line
            x: that.datalabelx(),
            y: that.datalabely(),
            zIndex: 7,
            formatter: function() {
              return vbiNumberFormat.gaugeFamilyDataLabelFormatter(
                this,
                that,
                that.progressdecimalseparator(),
                that.progressthousandseparator()
              );
            },

            style: {
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily: tfontFamily
            }
          }
        }
      },
      series: [
        {
          name:
            that.dataseriesname() !== "" ? that.dataseriesname() : options.tooltiptitle,
          data: [Number(options.datatest)],
          key: options.measureID,
          tooltip: {
            valuePrefix: that.tooltipvalueprefix(),
            valueSuffix: " " + that.tooltipvaluesuffix()
          }
        }
      ]
    };
    return defaultValue;
  };
}