function AngularGaugeChartUtil(){
    
    this.getDefaultValue = function(that, options) {
        var dependencyObject = options.dependencyObject;
        var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
        var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
        
         //To stop loading the fireeven twice - 1200 -- Vignesh G.
        var isLoad = false;

        var tmarginBottom = null;
        var tmarginLeft = null;
        var tmarginRight = null;
        var tmarginTop = null;
        var tspacingBottom = null;
        var tspacingLeft = null;
        var tspacingRight = null;
        var tspacingTop = null;
        var datuma;
        var maxima;
        var intermediata;
        var decimalsep;
        var thousandsep;
        var datatest;
        var datum;
        var intermediatum;
        var maximum;

        var tplotBackgroundColor = that.plotbackgroundcolor();
        var tminorTickWidth = 0;
        var ttickWidth = 0;
        var tdisplay = "none";
        var tbackgroundColor = that.datalabelbackgroundcolor();
        var tfontFamily = that.datalabelfontfamily();
        thousandsep = that.progressthousandseparator();
        decimalsep = that.progressdecimalseparator();
        intermediatum = that.intermediaterange().split(" to ");
        datum = that.startrange().split(" to ");
        maximum = that.endrange().split(" to");
        maxima = Number(maximum[1]);
        datuma = Number(datum[1]);
        intermediata = Number(intermediatum[1]);
        
        if (that.chartmarginbottom() !== "auto") {
            tmarginBottom = _.parseInt(that.chartmarginbottom(), 10);
        }
        if (that.chartmarginleft() !== "auto") {
            tmarginLeft = _.parseInt(that.chartmarginleft(), 10);
        }
        if (that.chartmarginright() !== "auto") {
            tmarginRight = _.parseInt(that.chartmarginright(), 10);
        }
        if (that.chartmargintop() !== "auto") {
            tmarginTop = _.parseInt(that.chartmargintop(), 10);
        }
        if (that.chartpaddingbottom() !== "auto") {
            tspacingBottom = _.parseInt(that.chartpaddingbottom(), 10);
        }
        if (that.chartpaddingleft() !== "auto") {
            tspacingLeft = _.parseInt(that.chartpaddingleft(), 10);
        }
        if (that.chartpaddingright() !== "auto") {
            tspacingRight = _.parseInt(that.chartpaddingright(), 10);
        }
        if (that.chartpaddingtop() !== "auto") {
            tspacingTop = _.parseInt(that.chartpaddingtop(), 10);
        }

        if (that.plottransparency() === true) {
            tplotBackgroundColor = "transparent";
        }
        if (that.yaxisenablemintick() === true) {
            tminorTickWidth = that.yaxisminortickwidth();
        }
        if (that.yaxisenablemajtick() === true) {
            if (_.parseInt(that.yaxistickwidth(), 10) > 0) {
                ttickWidth = that.yaxistickwidth();
            } else {
                ttickWidth = 1;
            }
        }
        if (that.yaxistitleenabled() === true) {
            tdisplay = "block";
        }
        if (that.datalabelbackgroundcolor() === "") {
            tbackgroundColor = null;
        }
        if (that.globalfont() === true) {
            tfontFamily = that.fontfamily();
        }

        var defaultValue = {
            chart: {
                type: "gauge",
                inverted: that.chartinverted(),
                alignTicks: that.chartalignticks(),
                animation: that.chartanimation(),
                // className: that.chartclassname(),
                events: {
                    click: function () {
                        that.fireEvent("chartonclick");
                    },

                    load: function () {
                                 /*var contextMenuOptions={event:event,
                                    enableContextMenu:that.enableContextMenu(),
                                    enableDisplayDataButton:that.enableDisplayDataButton(),
                                    enableMaximizeButton:that.enableMaximizeButton(),
                                    enableMoreActionsButton:that.enableMoreActionsButton()};

              //The If condition is fire the charafterload event only once - Fix 1200
              vbiContextMenu.attachContextMenu(contextMenuOptions);*/

                        //The If condition is fire the charafterload event only once - Fix 1200
                        if (!isLoad) {
                            that.fireEvent("chartafterload");
                            isLoad = true;
                        }

                        if (that.creditsenabled() === true) {
                            this.credits.element.onclick = function () {
                                window.open(that.creditshref(), "_blank" // <- This is what makes it open in a new window.
                                );
                            };
                        }
                    }
                },
                ignoreHiddenSeries: that.ignorehiddenseries(),
                marginBottom: tmarginBottom,
                marginLeft: tmarginLeft,
                marginRight: tmarginRight,
                marginTop: tmarginTop,
                spacingBottom: tspacingBottom,
                spacingLeft: tspacingLeft,
                spacingRight: tspacingRight,
                spacingTop: tspacingTop,
                pinchType: that.chartpinchtype(),
                zoomType: that.chartzoomtype(),
                panning: true,
                panKey: "shift",
                plotShadow: that.plotshadow(),
                reflow: that.chartflow() || false,
                shadow: that.chartshadow(),
                showaxes: that.showaxes(),
                resetZoomButton: {
                    position: {
                        align: that.zoombuttonalign(),
                        relativeTo: that.zoombuttonrelativeto(),
                        verticalAlign: that.zoombuttonverticalalign()
                    },
                    theme: {
                        fill: that.resetzoombuttonbackgroundcolor(),
                        r: that.resetzoombuttonradius(),
                        style: {
                            color: that.resetzoombuttontextcolor()
                        },
                        states: {
                            hover: {
                                fill: that.resetzoombuttonhoverbackgroundcolor(),
                                style: {
                                    color: that.resetzoombuttonhovertextcolor()
                                }
                            }
                        }
                    }
                },
                backgroundColor: that.chartbackgroundcolor(),
                borderColor: that.chartbordercolor(),
                borderRadius: that.chartborderradius(),
                borderWidth: that.chartborderwidth(),
                plotBackgroundColor: tplotBackgroundColor,
                plotBackgroundImage: that.plotbackgroundimage(),
                plotBorderColor: that.plotbordercolor(),
                plotBorderWidth: that.plotborderwidth(),
                selectionMarkerFill: that.zoomselectionareabackgroundcolor()
            },
            pane: {
                startAngle: -150,
                endAngle: 150,
                background: [{
                    backgroundColor: {
                        linearGradient: {
                            x1: 0,
                            y1: 0,
                            x2: 0,
                            y2: 1
                        },
                        stops: [
                            [
                                0,
                                "#FFF"
                            ],
                            [
                                1,
                                "#333"
                            ]
                        ]
                    },
                    borderWidth: 0,
                    outerRadius: "109%"
                }, {
                    backgroundColor: {
                        linearGradient: {
                            x1: 0,
                            y1: 0,
                            x2: 0,
                            y2: 1
                        },
                        stops: [
                            [
                                0,
                                "#333"
                            ],
                            [
                                1,
                                "#FFF"
                            ]
                        ]
                    },
                    borderWidth: 1,
                    outerRadius: "107%"
                }, {}, {
                    backgroundColor: "#DDD",
                    borderWidth: 0,
                    outerRadius: "105%",
                    innerRadius: "103%"
                }]
            },
            title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
            subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
            credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
            exporting: vbiHighchartsDefault.createDefaultObjects("commonExporting", that),
            navigation: vbiHighchartsDefault.createDefaultObjects("commonNavigation", that),
            yAxis: {
                min: Number(datum[0]),
                max: maxima,
                minorTickInterval: Number(that.yaxisminortickinterval()),
                minorTickColor: that.yaxisminortickcolor(),
                minorTickLength: that.yaxisminorticklength(),
                minorTickPosition: that.yaxisminortickposition(),
                minorTickWidth: tminorTickWidth,
                tickInterval: parseFloat(that.yaxistickinterval()),
                tickColor: that.yaxistickcolor(),
                tickLength: that.yaxisticklength(),
                tickPosition: that.yaxistickposition(),
                tickWidth: ttickWidth,
                labels: {
                    enabled: that.yaxislabelenabled(),
                    rotation: "auto",
                    step: 2,
                    formatter: function () {
                        var result = this.value;
                        if (this.value >= 1000000000000) {
                            result = this.value / 1000000000 + "T";
                        } else if (this.value >= 1000000000) {
                            result = this.value / 1000000000 + "B";
                        } else if (this.value >= 1000000) {
                            result = this.value / 1000000 + "M";
                        } else if (this.value >= 1000) {
                            result = this.value / 1000 + "k";
                        }

                        return that.yaxislabelprefix() + ' ' + result + ' ' + that.yaxislabelsuffix();
                    },

                    style: {
                        color: that.yaxislabelcolor(),
                        fontWeight: that.yaxislabelfontweight(),
                        //            "text-decoration": "underline",
                        textDecoration: that.yaxislabelfontweight(),
                        fontSize: that.yaxislabelfontsize() + "px",
                        fontFamily: that.yaxislabelfontfamily()
                    }
                },
                title: {
                    text: that.yaxistitletext(),
                    align: that.yaxistitlealign(),
                    rotation: that.yaxistitlerotation(),
                    style: {
                        color: that.yaxistitlecolor(),
                        fontWeight: that.yaxistitlefontweight(),
                        textDecoration: that.yaxistitlefontweight(),
                        fontSize: that.yaxistitlefontsize() + "px",
                        fontFamily: that.yaxistitlefontfamily(),
                        display: tdisplay
                    }
                },
                plotBands: [{
                    from: Number(datum[0]),
                    to: datuma,
                    color: that.datavaluecolor() // green
                }, {
                    from: datuma,
                    to: intermediata,
                    color: that.intermediatevaluecolor() // yellow
                }, {
                    from: intermediata,
                    to: maxima,
                    color: that.maximumvaluecolor() // red
                }]
            },
            loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
            tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
            plotOptions: {
                gauge: {
                    events: {
                        click: function () {
                            that.fireEvent("chartonpointclick");
                        }
                    },
                    dial: {
                        backgroundColor: that.gaugecolorpicker()
                    },
                    pivot: {
                        backgroundColor: that.gaugecolorpicker()
                    }
                }
            },
            series: [{
                name: options.test,
                key : options.measureID,
                data: [Number(options.datatest)],
                dataLabels: {
                    enabled: that.datalabelenabled(),
                    align: that.datalabelalign(),
                    rotation: that.datalabelrotation(),
                    shadow: that.datalabelshadow(),
                    verticalAlign: (that.datalabelverticalalign() === 'top') ? 'bottom' : ((that.datalabelverticalalign() === 'bottom') ? 'top' : 'middle'), //jshint ignore:line
                    x: that.datalabelx(),
                    y: that.datalabely(),
                    borderRadius: that.datalabelborderradius(),
                    backgroundColor: tbackgroundColor,
                    borderWidth: that.datalabelborderwidth(),
                    borderColor: that.datalabelbordercolor(),
                    formatter: function () {
                        return vbiNumberFormat.gaugeFamilyDataLabelFormatter(this,that,decimalsep,thousandsep);
                    },

                    style: {
                        color: that.datalabeltextcolor(),
                        fontSize: that.datalabelfontsize() + "px",
                        fontFamily: tfontFamily,
                        fontWeight: that.datalabelfontweight(),
                        textDecoration: that.datalabelfontweight(), //fontSize: that.datalabelfontsize() + "px"
                        visibility: "visible"
                    },

                    /* formatter: function() {
                        var s;
                        s = "<span style="font-size: " + that.datalabelfontsize() + "px;width:50px;">" + formatvalue + "</span>";
                        return s;
                      },
                    */
                    zIndex: 10
                }
            }]
        };
        return defaultValue;
    };
}