function FunnelPyramidChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        data: [
          {
            name: "Northeast",
            y: 2353233,
            color: "#7BB6EF"
          },
          {
            name: "Southeast",
            y: 1932832,
            color: "#A3A3A3"
          },
          {
            name: "Midwest",
            y: 1732331,
            color: "#99E395"
          },
          {
            name: "West",
            y: 1465932,
            color: "#F8AA6B"
          },
          {
            name: "Central",
            y: 982828,
            color: "#C098A6"
          }
        ]
      }
    ];
    return seriesData;
  };
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var defaultValue = {
      chart: {
        type: that.funnelcharttype().toLowerCase(),
        className: that.chartcssclassname(),
        events: {
          click: function() {
            that.fireEvent("chartonclick");
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            /*var contextMenuOptions={event:event,
                          enableContextMenu:that.enableContextMenu(),
                          enableDisplayDataButton:that.enableDisplayDataButton(),
                          enableMaximizeButton:that.enableMaximizeButton(),
                          enableMoreActionsButton:that.enableMoreActionsButton()};

    //The If condition is fire the charafterload event only once - Fix 1200
    vbiContextMenu.attachContextMenu(contextMenuOptions);*/

            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          }
        },
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            relativeTo: that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: {
              color: that.resetzoombuttontextcolor()
            },
            //
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: {
                  color: that.resetzoombuttonhovertextcolor()
                }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      plotOptions: {
        series: {
          showInLegend: that.legendenable(),
          borderColor: that.funnelbordercolor(),
          borderWidth: that.funnelborderwidth(),
          allowPointSelect: that.allowpointselect(),
          cursor: that.pointcursor(),
          turboThreshold: that.turbothreshold(),
          enableMouseTracking: that.enablemousetracking(),
          lineWidth: that.linewidth(),
          shadow: that.seriesshadow(),
          // neckWidth: that.funnelneckwidth(),
          // neckHeight: that.funnelneckheight(),
          // width: "90px",
          //height: "100px",
          point: {
            events: {
              click: function(event) {
                try {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  ); //that.colorChanged = 1;
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
              },

              select: function() {
                try {
                  that.selectedPoints = component
                    .highcharts()
                    .getSelectedPoints();
                  that.selectedPoints.push(this);
                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                  );
                  seriesLibrary.onSelectFunction(that);
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }

                /**
                               *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                               **/
              },

              unselect: function() {
                try {
                  // var unselectedPoints = component.highcharts().getSelectedPoints();
                  var index = that.selectedPoints.indexOf(this);
                  if (index > -1) {
                    that.selectedPoints.splice(index, 1);
                  }

                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                  );
                  if (that.selectedvalues() === "") {
                    that.selectedvalue("");
                  } else {
                    var select = seriesLibrary.createMembersData(
                      that,
                      that.categoriesIndex,
                      that.selectedPoints
                    );
                    that.selectedvalue(select[0]);
                  }
                  /**
                                   *Selectedvalue fix in all charts
                                   *Multiple Selection getting the last selected value.
                                   **/
                  if (that.clearSelect) {
                    if (that.selectedvalues() === "") {
                      that.clearSelect = false;
                    }
                  } else {
                    seriesLibrary.onSelectFunction(that);
                  } //clearselection callback issue on Onselect.
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
              }
            }
          },
          states: {
            hover: {
              enabled: that.funnelhoverenable(),
              brightness: that.funnelhoverbrightness()
            }
          },
          dataLabels: {
            zIndex: 100,
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            distance: Number(that.datalabeldistance()),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              if (that.result()) {
                that.customdatalabelFamily = "pie";
                if (
                  that.customdatalabel() !== "" &&
                  Object.keys(JSON.parse(that.customdatalabel() || "{}"))
                    .length &&
                  this.point.series.name.toLocaleLowerCase().indexOf("result") ==
                    -1 &&
                  this.key.toLocaleLowerCase().indexOf("result") == -1
                ) {
                  return vbiNumberFormat.barFamilyFormatterDataLabel(
                    this,
                    that,
                    that.decimalsep,
                    that.thousandsep,
                    false
                  );
                } else {
                  return vbiNumberFormat.pieFamilyDataLabelFormatter(
                    this,
                    that,
                    that.decimalsep,
                    that.thousandsep,
                    false
                  );
                }
              } else {
                if (that.datavaluedecimals() !== "auto") {
                  return (
                    that.datalabelprefix() +
                    " " +
                    Highcharts.numberFormat(
                      this.y,
                      that.decimal(),
                      that.decimalsep,
                      that.thousandsep
                    ) +
                    " " +
                    that.datalabelsuffix()
                  );
                } else {
                  return (
                    that.datalabelprefix() +
                    " " +
                    Highcharts.numberFormat(
                      this.y,
                      that.decimal(),
                      that.decimalsep,
                      that.thousandsep
                    ) +
                    " " +
                    that.datalabelsuffix()
                  );
                }
              }
            },

            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() === true
                  ? this.fontfamily()
                  : that.datalabelfontfamily()
            }
          }
        }
      },
      series: options.seriesData
    };
    return defaultValue;
  };
  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.getMeasureMembersKeyAndText = function() {
        var measureMemberKeys = [];
        var measureMemberText = [];
        if (component.dataRes !== undefined && component.dataRes !== '') {
            try {
                var mesIndex = component.getMeasureIndex();
                for (var i = 0; i < component.dataRes.dimensions[mesIndex].members.length; i++) {
                    measureMemberKeys.push(component.dataRes.dimensions[mesIndex].members[i].key);
                    measureMemberText.push(component.dataRes.dimensions[mesIndex].members[i]["picker_text"]);
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return [
            measureMemberText,
            measureMemberKeys
        ];
    };
        component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
            return seriesLibrary.getDataSeries(component, 'pie');
        };

        component.getChartType = function() {
            return 'funnel';
        };

        component.getDataSeriesColor = function() {
            return component.dataseriescolor();
        };

        //Function to get Series Name
        component.getMeasureMembers = function() {
            return seriesLibrary.getMeasureMembers(component);
        };

        component.getDimensionAndMeasure = function() {
            var dimensionAndMeasure = [];
            if (component.dataRes !== undefined && component.dataRes !== '')
            // if (component.dataRes !== undefined && component.dataRes !== "")
            {
                for (var i = 1; i < component.dataRes.dimensions.length; i++) {
                    dimensionAndMeasure.push(component.dataRes.dimensions[i].text);
                }
            }

            return dimensionAndMeasure;
        };

        component.getDimensionList = function() {
            // var dimlist =[];
            var dimensions = [];
            if (component.result() !== undefined && component.result() !== '') {
                try {
                    for (var i = 0; i < component.result().dimensions.length; i++) {
                        dimensions.push(component.result().dimensions[i].text);
                    }
                } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                }
            }

            return dimensions;
        };

        component.getChartFamily = function() {
            return 'pie';
        };

        component.getDimensionMembersJson = function(dimIndex, JSONType) {
            return JSON.stringify(seriesLibrary.getDimensionMembersJson(component, dimIndex, JSONType));
        };

        component.getMeasuresNamesForFormatter = function(){
              return vbiNumberFormat.getMeasuresNamesForFormatter(component);
        };

        component.componentDeleted = function() {
            $('#dsui_' + componentID).remove();
        };

        component.getDimensionJson = function() {
            // var dimlist =[];
            var dimJson = {};
            if (component.result() !== undefined && component.result() !== '' && component.result() !== null) {
                try {
                    var resultSet = component.result().dimensions;
                    for (var i = 0; i < resultSet.length; i++) {
                        if (resultSet[i].containsMeasures !== true) {
                            dimJson[resultSet[i].key] = {
                                'text': resultSet[i].text,
                                'index': i
                            };
                        }
                    }
                } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                }
            }

            return JSON.stringify(dimJson);
        };

  }
}