function marimekkoSeries() {//jshint ignore:line
  // alert('[[Executed columnBarSeries]]');
  var that = this;
  that.createSeriesData = function(component, type, defaultValue) {
    var self = this;
    /*function calculateValue(v1, v2, op) {
      switch (op) {
      case '+':
        return v1 + v2;
      case '-':
        return v1 - v2;
      case '*':
        return v1 * v2;
      case '/':
        return v1 / v2;
      }
    }*/

    component.categoriesIndex = [];
    //var columnCount = 0;
    var DefaultColor = [
      '#B586DA',
      '#FF6657',
      '#F3A730',
      '#946B66',
      '#B0AD53',
      '#7AC1DE',
      '#F1C337',
      '#566C6C',
      '#A1CC54',
      '#543F1E'
    ];
    var seriesColor = [];
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = [];
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }

    var measureColorPair;
    var categoriesVariable = [];
    if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
      measureColorPair = JSON.parse(component.measurecolorpair());
    }

    if (component.widthdimension() == 'none') {
      this.createSmokeScreen(component.$(), 'Please Select a Width Dimension from the Data Utility');
    }

    if (component.stackeddimension() == 'none') {
      this.createSmokeScreen(component.$(), 'Please Select a Stacked Dimension from the Data Utility');
    }
    //to check for the first time if we get undefined or blank value
    for (var itr = 0; itr < component.dataRes.dimensions.length; itr++) {
      var dimObj = component.dataRes.dimensions[itr];
      if (dimObj.containsMeasures !== true) {
        if (component.widthdimension() === null || component.widthdimension() === '' || component.widthdimension() === undefined) {
          component.widthdimension(dimObj.key);
        } else if (component.stackeddimension() === null || component.stackeddimension() === '' || component.stackeddimension() === undefined) {
          component.stackeddimension(dimObj.key);
        }
      } else if (dimObj.containsMeasures === true && (component.measurelist() === '' || component.measurelist() === null || component.measurelist() === undefined)) {
        component.measurelist(dimObj.members[0].key);
      }
    }
    //to store the measure, stacking and widthIndex
    var measureData = 0, widthIndex = -1, stackIndex = -1,measureIndex = -1;
    if (component.widthdimension() && component.stackeddimension() && component.measurelist()) {
      //Since data utility property is removed the above line will check the datautily is fully configured or not
      for (var itr = 0; itr < component.dataRes.dimensions.length; itr++) {
        var dimObj = component.dataRes.dimensions[itr];
        if (dimObj.containsMeasures === true) {
          $.each(dimObj.members, function(index, value) {
            if (component.measurelist() == value.key) {
              measureData = index;
            }
          });

          measureIndex = itr;
        } else if (dimObj.key == component.widthdimension()) {
          widthIndex = itr;
        } else if (dimObj.key == component.stackeddimension()) {
          stackIndex = itr;
        }
      }
      //that.firePropertiesChanged(['chartaggregation']);
    } else {//edit initial view dataRes
      measureData = 0;
      var dimCount = 0;
      for (var itr = 0; itr < component.dataRes.dimensions.length; itr++) {
        var dimObj = component.dataRes.dimensions[itr];
        if (dimObj.containsMeasures) {
          measureIndex = itr;
        }

        if (!dimObj.containsMeasures && dimCount <= 1) {
          dimCount++;
          if (dimCount == 1){
            widthIndex = itr;
          }
          else{
            stackIndex = itr;
          }
        }
      }
    }

    if (widthIndex == -1) {
      noData = 4;//jshint ignore:line
      return;
    }

    if (stackIndex == -1) {
      noData = 5;//jshint ignore:line
      return;
    }

    var ruleInfo = {};
    //var ruleArray = [];
    var isCFApplied = false;
    //var isMeasureConFormattingApplied = false;
    if (component.ruletable() !== undefined && component.ruletable() !== '') {
      that.updateRuleInfo(component, 'pie');
      ruleInfo = JSON.parse(component.ruletable());
    }

    $.each(ruleInfo, function() {
      isCFApplied = true;
    });
    //--------------------------
    var stackMemberResultIndex = -1;
    //create a finalDataArray prototpye based on the members of the stacking
    var finalDataArray = [];
    var unitOfMeasure = component.dataRes.dimensions[measureIndex].members[measureData].unitOfMeasure;
    var scalingFactor = component.dataRes.dimensions[measureIndex].members[measureData].scalingFactor;
    $.each(component.dataRes.dimensions[stackIndex].members, function(staIndex, objStack) {
      if (objStack.type != 'RESULT') {
        var serKey = measureIndex + ':' + measureData + '-' + stackIndex + ':' + staIndex;
        var stackDimensionKey = component.dataRes.dimensions[stackIndex].members[staIndex].key;
        var tempObj = {
          name: objStack.text,
          data: [],
          type: 'marimekko',
          total: 0,
          percentage: 0,
          color: '',
          key: serKey,
          "dimension_key": stackDimensionKey
        };
        var scalingFactorTxt = '';
        var unitMeasureTxt = '';
        if (component.showunit() && unitOfMeasure !== undefined && unitOfMeasure !== '') {
          unitMeasureTxt = ' ( in ' + unitOfMeasure + ' )';
        }

        if (component.scalingfactorenable()) {
          scalingFactorTxt = ' (* ' + Math.pow(10, scalingFactor) + ') ';
        }

        tempObj.name = tempObj.name + scalingFactorTxt + unitMeasureTxt;  //to create the internal array for the members of the xAxis labels
        //var total = 0;
        var widthMemberResultIndex = 0;
        $.each(component.dataRes.dimensions[widthIndex].members, function(widIndex, objWidth) {
          //generate key
          if (component.showtotal() || objWidth.type != 'RESULT') {
            //generate key
            if (objWidth.type != 'RESULT') {
              var widthDimensionKey = component.dataRes.dimensions[widthIndex].members[widIndex].key;
              var tempKey = measureIndex + ':' + measureData + '-' + stackIndex + ':' + staIndex + '-' + widthIndex + ':' + widIndex;
              tempObj['data'].push({
                data: [],
                x: 0,
                y: 0,
                z: 0,
                key: tempKey,
                "dimension_key": widthDimensionKey
              });
              if (categoriesVariable[widIndex - widthMemberResultIndex] === undefined) {
                categoriesVariable[widIndex - widthMemberResultIndex] = objWidth.text;
                component.categoriesIndex.push(tempKey);
              }
            } else {
              widthMemberResultIndex = 1;
            }

            if (widIndex == component.dataRes.dimensions[widthIndex].members.length - 1 && component.showtotal()) {
              var widthDimensionKey = component.dataRes.dimensions[widthIndex].members[widIndex].key;
              var tempKey = measureIndex + ':' + measureData + '-' + stackIndex + ':' + staIndex;
              tempObj['data'].push({
                data: [],
                x: widIndex + 1 - widthMemberResultIndex,
                y: 0,
                z: 0,
                key: tempKey,
                "dimension_key": widthDimensionKey
              });
              if (categoriesVariable[widIndex + 1 - widthMemberResultIndex] === undefined) {
                categoriesVariable[widIndex + 1 - widthMemberResultIndex] = 'Total Result';
                component.categoriesIndex.push(tempKey);
              }
            }
          } else {
            widthMemberResultIndex = 1;
          }
        });

        finalDataArray.push(tempObj);
        tempObj = null;
      } else {
        //Add result member to avoid null(DSXR-2408)
        finalDataArray.push({});
        stackMemberResultIndex = staIndex;
      }
    });

    var totalZValue = [];
    var finalTotal = [];
    // if( (measureData != "" && measureData != null && measureData !== undefined) && (widthIndex != "" && widthIndex != null && widthIndex !== undefined)
    //     && (stackIndex != "" && stackIndex != null && stackIndex !== undefined) && (measureIndex != "" && measureIndex != null && measureIndex !== undefined) )
    // {
    var reduceWidthIndex = -1;
    //creating a data array and parse through the tuple
    for (itr = 0; itr < component.dataRes.tuples.length; itr++) {
      var tupleObj = component.dataRes.tuples[itr];
      var flag = true;
      for (var tubIndex = 0; tubIndex < component.dataRes.tuples[itr].length; tubIndex++) {
        if (component.dataRes.dimensions[tubIndex].members[tupleObj[tubIndex]].type == 'RESULT') {
          flag = false;
          break;
        }
      }

      if (component.dataRes.dimensions[widthIndex].members[tupleObj[widthIndex]].type == 'RESULT') {
        reduceWidthIndex = tupleObj[widthIndex];
      }

      var localWidthIndex = tupleObj[widthIndex] > reduceWidthIndex && reduceWidthIndex != -1 ? tupleObj[widthIndex] - 1 : tupleObj[widthIndex];
      if (component.dataRes.data[itr] === null) {
        continue;
      }
      //check for measure and result
      if (tupleObj[measureIndex] == measureData && flag && stackMemberResultIndex != tupleObj[stackIndex]) {
        finalDataArray[tupleObj[stackIndex]].data[localWidthIndex].data.push(component.dataRes.data[itr]);
        finalDataArray[tupleObj[stackIndex]].data[localWidthIndex].x = localWidthIndex;
      }
    }
    //store the z value in each and bar value aggregation
    $.each(finalDataArray, function(index, value) {     
      if (value && value.hasOwnProperty('data')) {
        $.each(value.data, function(internalIndex, internalObj) {
          var yvalue = 0;
          if (internalObj.data && internalObj.data.length > 0) {
            yvalue = that.barValueAggregation(component, internalObj.data);
          }

          finalTotal.push(yvalue);
          if (totalZValue[internalIndex] === undefined) {
            totalZValue[internalIndex] = [];
          }

          totalZValue[internalIndex].push(yvalue);
        });
      }
    });

    var sum = 0;
    $.each(finalTotal, function(index, value) {
      sum += value;
    });

    finalTotal = sum;
    //store the z value in each and bar value aggregation
    $.each(totalZValue, function(index, value) {
      var zvalue = 0;
      if (value && value.length > 0) {
        $.each(value, function(index, val) {
          zvalue += val;
        });
      }

      totalZValue[index] = zvalue;
    });
    //Remove result member from series
    if (stackMemberResultIndex > -1) {
      finalDataArray.splice(stackMemberResultIndex, 1);
    }

    if (component.showtotal()) {
      totalZValue[totalZValue.length - 1] = finalTotal;
      finalTotal = finalTotal * 2;
    }

    var totalZvalueWithoutUndefined = [];
    //Remove undefined from array
    $.each(totalZValue, function(index, value) {
      if (value !== undefined) {
        totalZvalueWithoutUndefined.push(value);
      }
    });

    totalZValue = totalZvalueWithoutUndefined;
    //generate the ratio of total
    $.each(totalZValue, function(index, value) {
      totalZValue[index] = value / finalTotal * 100;
      if (component.xstacklabelsenabled() && component.xstackpercentageenabled()) {
        categoriesVariable[index] = categoriesVariable[index] + '(' + totalZValue[index].toString().replace(/(\.\d\d)\d+|([\d.]*)[^\d.]/, '$1$2') + '%)';
      } else if (component.xstacklabelsenabled()) {
        categoriesVariable[index] = categoriesVariable[index] + '(' + value.toString().replace(/(\.\d\d)\d+|([\d.]*)[^\d.]/, '$1$2') + ')';
      }
    });
    //store the z value in each and bar value aggregation
    $.each(finalDataArray, function(index, value) {
      if( measureColorPair && measureColorPair[value["dimension_key"]] && measureColorPair[value["dimension_key"]].color){
        value.color = measureColorPair[value["dimension_key"]].color;
      }else{
        value.color = self.getSeriesColors(component, seriesColor, index, DefaultColor);
      }

      var temp = 0;
      if (value && value.hasOwnProperty('data')) {
        $.each(value.data, function(internalIndex, internalObj) {
          var yvalue = 0;
          if (internalObj.data && internalObj.data.length > 0) {
            yvalue = that.barValueAggregation(component, internalObj.data);
          }

          internalObj['z'] = totalZValue[internalIndex];
          internalObj['y'] = yvalue;
          temp += internalObj['y'];
          internalObj['x'] = internalIndex;  //conditional formatting will go here for color
          // internalObj["color"]=self.getSeriesColors(component, seriesColor, index, DefaultColor);
        });
      }

      value.total = temp;
      value.percentage = temp / finalTotal * 100;
    });

    if (component.showtotal()) {
      $.each(finalDataArray, function(objIndex, objValue) {
        objValue.data[objValue.data.length - 1].data.push(objValue.total);
        objValue.data[objValue.data.length - 1].y = objValue.total;
      });
    }

    if (isCFApplied) {
      that.createCFSeriesData(component, finalDataArray, component.fulljson());
    }

    defaultValue.xAxis.categories = [];
    defaultValue.xAxis.categories = defaultValue.xAxis.categories.concat(categoriesVariable);
    defaultValue.series = finalDataArray;
    component.dataseriescolor(seriesColor.join());
   // categoriesIndex = categoriesVariable;
    return categoriesVariable;
  };

  that.createCFSeriesData = function(component, originalArray, completeJson) {
    var self = this;
    function calculateValue(v1, v2, op) {
      switch (op) {
      case '+':
        return v1 + v2;
      case '-':
        return v1 - v2;
      case '*':
        return v1 * v2;
      case '/':
        return v1 / v2;
      }
    }

    //var columnCount = 0;
    //to store the measure, stacking and widthIndex
    var measureData = 0, widthIndex = -1, stackIndex = -1, measureIndex = -1;
    
    if (component.widthdimension() && component.stackeddimension() && component.measurelist()) {
    //Since data utility property is removed the above line will check the datautily is fully configured or not
      for (var itr = 0; itr < completeJson.dimensions.length; itr++) {
        var dimObj = completeJson.dimensions[itr];
        if (dimObj.containsMeasures === true) {
          $.each(dimObj.members, function(index, value) {
            if (component.measurelist() == value.key) {
              measureData = index;
            }
          });

          measureIndex = itr;
        } else if (dimObj.key == component.widthdimension()) {
          widthIndex = itr;
        } else if (dimObj.key == component.stackeddimension()) {
          stackIndex = itr;
        }
      }
    }else{
      var dimCount = 0;
     for (var itr = 0; itr < component.dataRes.dimensions.length; itr++) {
        var dimObj = component.dataRes.dimensions[itr];
        if (dimObj.containsMeasures) {
          measureIndex = itr;
        }

        if (!dimObj.containsMeasures && dimCount <= 1) {
          dimCount++;
          if (dimCount == 1){
            widthIndex = itr;
          }
          else{
            stackIndex = itr;
          }
        }
      }

    }
    

    
   

    if (widthIndex == -1) {
      noData = 4;//jshint ignore:line
      return;
    }

    if (stackIndex == -1) {
      noData = 5;//jshint ignore:line
      return;
    }

    var ruleInfo = {};
    var isCFApplied = false;
    var isMeasureConFormattingApplied = false;
    if (component.ruletable() !== undefined && component.ruletable() !== '') {
      ruleInfo = JSON.parse(component.ruletable());
    }

    $.each(ruleInfo, function(k, ruleJson) {
      isCFApplied = true;
      var ruleType = ruleJson['cfui-ruleType'];
      switch (ruleType) {
      case 'single_measure':
        isMeasureConFormattingApplied = true;
        break;
      case 'measure_calculation':
        isMeasureConFormattingApplied = true;
        break;
      case 'target_value':
        isMeasureConFormattingApplied = true;
        break;
      case 'dimension':
        break;
      }
    });
    //--------------------------
    var stackMemberResultIndex = -1;
    //create a finalDataArray prototpye based on the members of the stacking
    var finalDataArray = [];
    var unitOfMeasure = completeJson.dimensions[measureIndex].members[measureData].unitOfMeasure;
    var scalingFactor = completeJson.dimensions[measureIndex].members[measureData].scalingFactor;
    $.each(completeJson.dimensions[stackIndex].members, function(staIndex, objStack) {
      if (objStack.type != 'RESULT') {
        var serKey = measureIndex + ':' + measureData + '-' + stackIndex + ':' + staIndex;
        var stackDimensionKey = completeJson.dimensions[stackIndex].members[staIndex].key;
        var tempObj = {
          name: objStack.text,
          data: [],
          type: 'marimekko',
          total: 0,
          percentage: 0,
          color: '',
          key: serKey,
          "dimension_key": stackDimensionKey
        };
       // var scalingFactorTxt = '';
       // var unitMeasureTxt = '';
        /*if (component.showunit() && unitOfMeasure !== undefined && unitOfMeasure !== '') {
          unitMeasureTxt = ' ( in ' + unitOfMeasure + ' )';
        }

        if (component.scalingfactorenable() && scalingFactor != 0) {
          scalingFactorTxt = ' * ' + Math.pow(10, scalingFactor) + ' ';
        }*/

        tempObj.name = self.formatSeriesName(component, tempObj.name, '', {'scalingFactor': scalingFactor || 0, 'unitOfMeasure': unitOfMeasure || ''});
        //to create the internal array for the members of the xAxis labels
        //var total = 0;
        var widthMemberResultIndex = 0;
        $.each(completeJson.dimensions[widthIndex].members, function(widIndex, objWidth) {
          //generate key
          if (component.showtotal() || objWidth.type != 'RESULT') {
            //generate key
            if (objWidth.type != 'RESULT') {
              var widthDimensionKey = completeJson.dimensions[widthIndex].members[widIndex].key;
              var tempKey = measureIndex + ':' + measureData + '-' + stackIndex + ':' + staIndex + '-' + widthIndex + ':' + widIndex;
              tempObj['data'].push({
                data: [],
                x: 0,
                y: 0,
                z: 0,
                key: tempKey,
                "dimension_key": widthDimensionKey
              });
            } else {
              widthMemberResultIndex = 1;
            }

            if (widIndex == completeJson.dimensions[widthIndex].members.length - 1 && component.showtotal()) {
              var widthDimensionKey = completeJson.dimensions[widthIndex].members[widIndex].key;
              var tempKey = measureIndex + ':' + measureData + '-' + stackIndex + ':' + staIndex;
              tempObj['data'].push({
                data: [],
                x: widIndex + 1 - widthMemberResultIndex,
                y: 0,
                z: 0,
                key: tempKey,
                "dimension_key": widthDimensionKey
              });
            }
          } else {
            widthMemberResultIndex = 1;
          }
        });

        finalDataArray.push(tempObj);
        tempObj = null;
      } else {
        //Add result member to avoid null(DSXR-2408)
        finalDataArray.push({});
        stackMemberResultIndex = staIndex;
      }
    });

    var totalZValue = [];
    var finalTotal = [];
    // if( (measureData != "" && measureData != null && measureData !== undefined) && (widthIndex != "" && widthIndex != null && widthIndex !== undefined)
    //     && (stackIndex != "" && stackIndex != null && stackIndex !== undefined) && (measureIndex != "" && measureIndex != null && measureIndex !== undefined) )
    // {
    var reduceWidthIndex = -1;
    //creating a data array and parse through the tuple
    for (var itr = 0; itr < completeJson.tuples.length; itr++) {
      var tupleObj = completeJson.tuples[itr];
      var flag = true;
      for (var tubIndex = 0; tubIndex < completeJson.tuples[itr].length; tubIndex++) {
        if (completeJson.dimensions[tubIndex].members[tupleObj[tubIndex]].type == 'RESULT') {
          flag = false;
          break;
        }
      }

      if (completeJson.dimensions[widthIndex].members[tupleObj[widthIndex]].type == 'RESULT') {
        reduceWidthIndex = tupleObj[widthIndex];
      }

      var localWidthIndex = tupleObj[widthIndex] > reduceWidthIndex && reduceWidthIndex != -1 ? tupleObj[widthIndex] - 1 : tupleObj[widthIndex];
      if (completeJson.data[itr] === null) {
        continue;
      }
      //check for measure and result
      if (tupleObj[measureIndex] == measureData && flag && stackMemberResultIndex != tupleObj[stackIndex]) {
        var sfvalue = completeJson.data[itr];
        var scalingFactor = completeJson.dimensions[measureIndex].members[measureData].scalingFactor;
        if (scalingFactor !== undefined && scalingFactor !== 0) {
          sfvalue = sfvalue * Math.pow(10, scalingFactor);
        }

        finalDataArray[tupleObj[stackIndex]].data[localWidthIndex].data.push(sfvalue);
        finalDataArray[tupleObj[stackIndex]].data[localWidthIndex].x = localWidthIndex;
      }
      //Conditional formatting styles
      if (isMeasureConFormattingApplied) {
        //check for measure and result
        if (flag && stackMemberResultIndex != tupleObj[stackIndex]) {
          if (finalDataArray[tupleObj[stackIndex]].data[localWidthIndex][completeJson.dimensions[measureIndex].members[tupleObj[measureIndex]].key] === undefined) {
            finalDataArray[tupleObj[stackIndex]].data[localWidthIndex][completeJson.dimensions[measureIndex].members[tupleObj[measureIndex]].key] = [];
          }

          var sfvalue = completeJson.data[itr];
          var scalingFactor = completeJson.dimensions[measureIndex].members[tupleObj[measureIndex]].scalingFactor;
          if (scalingFactor !== undefined && scalingFactor !== 0) {
            sfvalue = sfvalue * Math.pow(10, scalingFactor);
          }

          finalDataArray[tupleObj[stackIndex]].data[localWidthIndex][completeJson.dimensions[measureIndex].members[tupleObj[measureIndex]].key].push(sfvalue);
        }
      }
    }
    //Remove result member from series
    if (stackMemberResultIndex > -1) {
      finalDataArray.splice(stackMemberResultIndex, 1);
    }
    //store the z value in each and bar value aggregation
    $.each(finalDataArray, function(index, value) {
      var temp = 0;
      if (value && value.hasOwnProperty('data')) {
        $.each(value.data, function(internalIndex, internalObj) {
          var yvalue = 0;
          if (internalObj.data && internalObj.data.length > 0) {
            yvalue = that.barValueAggregation(component, internalObj.data);
          }

          if (isMeasureConFormattingApplied) {
            for (var mIndex = 0; mIndex < completeJson.dimensions[measureIndex].members.length; mIndex++) {
              if (completeJson.dimensions[measureIndex].members[mIndex].type != 'RESULT') {
                if (internalObj[completeJson.dimensions[measureIndex].members[mIndex].key] && internalObj[completeJson.dimensions[measureIndex].members[mIndex].key].length > 0) {
                  internalObj[completeJson.dimensions[measureIndex].members[mIndex].key] = that.barValueAggregation(component, internalObj[completeJson.dimensions[measureIndex].members[mIndex].key]);
                }
              }
            }
          }

          internalObj['z'] = totalZValue[internalIndex];
          internalObj['y'] = yvalue;
          temp += internalObj['y'];
          internalObj['x'] = internalIndex;
          if (isCFApplied) {
            $.each(ruleInfo, function(k, ruleJson) {
              var ruleType = ruleJson['cfui-ruleType'];
              switch (ruleType) {
              case 'single_measure':
                var staticVal1 = '';
                var point = 0;
                var smOp = ruleJson['cfui-operator'];
                point = internalObj[ruleJson['cfui-comparisionMeasure'].key];
                if (ruleJson['cfui-comparisionValueType'] == 'static') {
                  if (smOp == 'bt') {
                    staticVal1 = [
                      ruleJson['cfui-static_comparisionValue1'],
                      ruleJson['cfui-static_comparisionValue2']
                    ];
                  } else {
                    staticVal1 = ruleJson['cfui-static_comparisionValue1'];
                  }
                } else if (ruleJson['cfui-dynamicSelectionType'] == 'measure_selection') {
                  if (smOp == 'bt') {
                    staticVal1 = [
                      internalObj[ruleJson['cfui-dynamic_comparisionValue1'].key],
                      internalObj[ruleJson['cfui-dynamic_comparisionValue2'].key]
                    ];
                  } else {
                    staticVal1 = [internalObj[ruleJson['cfui-dynamic_comparisionValue1'].key]];
                  }
                } else if (ruleJson['cfui-dynamicSelectionType'] == 'cell_selection') {
                  if (smOp == 'bt') {
                    staticVal1 = [
                      VbiUtil.prototype.trendCellSelectionObjToDataValue(completeJson, ruleJson['dynamiccellselection'].key).data,
                      VbiUtil.prototype.trendCellSelectionObjToDataValue(completeJson, ruleJson['dynamiccellselection2'].key).data
                    ];
                  } else {
                    staticVal1 = VbiUtil.prototype.trendCellSelectionObjToDataValue(completeJson, ruleJson['dynamiccellselection'].key).data;
                  }
                }

                if (that.checkValues(point, staticVal1, smOp)) {
                  internalObj.color = ruleJson['inputcondformat'];
                  internalObj.states = {hover: {color: ruleJson['inputcondformat']}};
                  internalObj.marker = {
                    fillColor: ruleJson['inputcondformat'],
                    states: {hover: {fillColor: ruleJson['inputcondformat']}}
                  };
                }

                break;
              case 'measure_calculation':
                var smOp = ruleJson['cfui-operator'];
                point = internalObj[ruleJson['cfui-comparisionMeasure'].key];
                var StaticVal = calculateValue(internalObj[ruleJson['cfui-calcMeasure1'].key], internalObj[ruleJson['cfui-calcMeasure2'].key], ruleJson['cfui-calcOperator']);
                if (that.checkValues(point, StaticVal, smOp)) {
                  internalObj.color = ruleJson['inputcondformat'];
                  internalObj.states = {hover: {color: ruleJson['inputcondformat']}};
                  internalObj.marker = {
                    fillColor: ruleJson['inputcondformat'],
                    states: {hover: {fillColor: ruleJson['inputcondformat']}}
                  };
                }

                break;
              case 'target_value':
              var targetValue;
                if (ruleJson['cfui-targetValueType'] == 'static') {
                   targetValue = ruleJson['cfui-static_targetValue'];
                } else if (ruleJson['cfui-dynamicSelectionType'] == 'measure_selection') {
                   targetValue = [internalObj[ruleJson['cfui-dynamic_targetValue'].key]];
                } else if (ruleJson['cfui-dynamicSelectionType'] == 'cell_selection') {
                   targetValue = VbiUtil.prototype.trendCellSelectionObjToDataValue(completeJson, ruleJson['dynamiccellselection'].key).data;
                }

                var point = internalObj[ruleJson['cfui-comparisionMeasure'].key];
                var smOp = 'bt';
                var targetRules = ruleJson['cfui-targetRules'];
                for (var tIndex = 0; tIndex < targetRules.length; tIndex++) {
                  var rule = targetRules[tIndex];
                  var from = Number(targetValue) * (Number(rule.from) / 100);
                  var to = Number(targetValue) * (Number(rule.to) / 100);
                  var compValue = [
                    from,
                    to
                  ];
                  if (that.checkValues(point, compValue, smOp)) {
                    internalObj.color = rule.color;
                    internalObj.states = {hover: {color: rule.color}};
                    internalObj.marker = {
                      fillColor: rule.color,
                      states: {hover: {fillColor: rule.color}}
                    };
                  }
                }

                break;
              case 'dimension':
                var dimensionkeyArr = internalObj.key.split('-');
                if (dimensionkeyArr.length >= 3 && (dimensionkeyArr[1].split(':')[0] == ruleJson['cfui-dimension'].index && dimensionkeyArr[1].split(':')[1] == ruleJson['cfui-member'].index || dimensionkeyArr[2].split(':')[0] == ruleJson['cfui-dimension'].index && dimensionkeyArr[2].split(':')[1] == ruleJson['cfui-member'].index)) {
                  internalObj.color = ruleJson['inputcondformat'];
                  internalObj.states = {hover: {color: ruleJson['inputcondformat']}};
                  internalObj.marker = {
                    fillColor: ruleJson['inputcondformat'],
                    states: {hover: {fillColor: ruleJson['inputcondformat']}}
                  };
                }

                break;
              }
            });
          }
        });
      }

      value.total = temp;
      value.percentage = temp / finalTotal * 100;
    });

    for (var oIndex = 0; oIndex < originalArray.length; oIndex++) {
      for (var filteredIndex = 0; filteredIndex < finalDataArray.length; filteredIndex++) {
        if (originalArray[oIndex]["dimension_key"] == finalDataArray[filteredIndex]["dimension_key"]) {
          for (var oDataIndex = 0; oDataIndex < originalArray[oIndex].data.length; oDataIndex++) {
            for (var filteredDataIndex = 0; filteredDataIndex < finalDataArray[filteredIndex].data.length; filteredDataIndex++) {
              if (originalArray[oIndex].data[oDataIndex]["dimension_key"] == finalDataArray[filteredIndex].data[filteredDataIndex]["dimension_key"]) {
                if (finalDataArray[filteredIndex].data[filteredDataIndex].hasOwnProperty('color')) {
                  originalArray[oIndex].data[oDataIndex].color = finalDataArray[filteredIndex].data[filteredDataIndex].color;
                  originalArray[oIndex].data[oDataIndex].states = {hover: {color: finalDataArray[filteredIndex].data[filteredDataIndex].color}};
                  // originalArray[oIndex].data[oDataIndex].marker ={fillColor:finalDataArray[filteredIndex].data[filteredDataIndex].color ,states:{hover:{ fillColor:finalDataArray[filteredIndex].data[filteredDataIndex].color}}}
                  originalArray[oIndex].data[oDataIndex].marker = {
                    states: {
                      hover: {
                        fillColor: finalDataArray[filteredIndex].data[filteredDataIndex].color,
                        lineColor: finalDataArray[filteredIndex].data[filteredDataIndex].color
                      }
                    }
                  };
                }

                break;
              }
            }
          }

          break;
        }
      }
    }
  };
}
